#ifndef SMW_FUNCS_H_
#define SMW_FUNCS_H_

#include "smw_rtl.h"

typedef struct CollInfo {
  uint8 r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11;
} CollInfo;

typedef struct HdmaPtrs {
  const uint8 *r4, *r6;
} HdmaPtrs;

typedef struct PairU8 {
  uint16 first, second;
} PairU8;


typedef struct CalcTiltPlatformArgs {
  uint16 temp14b0;
  uint16 temp14b2;
  uint16 temp14bc;
  uint16 temp14bf;
} CalcTiltPlatformArgs;

typedef struct CheckPlatformCollRet {
  PointU16 pt;
  bool retval;
  bool out_of_bounds;
} CheckPlatformCollRet;

const uint16 *GetLayerLayoutPtr(int layer, int top);
const uint16 *GetPlayerPalette();
const uint16 *GetMap16RomAddr(uint8 bank, uint16_t addr);
const uint16 *Lm_GetMap16RomAddr(uint16 addr);

// Bank 0
PairU16 BufferFileSelectText_009DB5(uint8 k);
PairU16 GetPlayerLevelCollisionMap16ID_Entry2(uint8 k);
PairU16 GetPlayerLevelCollisionMap16ID_Entry2(uint8 k);
PairU16 GetPlayerLevelCollisionMap16ID_WallRun(uint8 k);
PairU16 HexToDec(uint8 a);
PairU16 OwPrompt03_OverworldLifeExchanger_00974C(uint8 a);
uint8 CheckWaterSlope(uint8 a);
uint8 CheckWhatSlopeSpriteIsOn(uint8 a, uint8 r10, uint8 r12, uint8 *r8_slope_type);
uint8 GameMode07_TitleScreenDemo_009CBE(void);
uint8 HandleMenuCursor_Main_ReturnsTwice(uint8 j);
uint16 ManipulateMode7Image_008B2B(uint16 k, uint8 r0);
uint8 ModifyMap16IDForSpecialBlocks(uint8 a);
uint8 PlayerGFXRt_00E45D(uint8 j, uint8 r4, uint8 r5, uint8 r6);
uint8 RunPlayerBlockCode_00F3E9(uint8 a, uint8 j);
uint8 RunPlayerBlockCode_00F43F(void);
uint8 RunPlayerBlockCode_00F443(void);
PairU8 UpdateHDMAWindowBuffer_00CC14(uint16 j, HdmaPtrs hptr, uint8 r1);
uint8 sub_F40A(uint8 k, uint8 j, uint8 a);
void BufferFileSelectText_Entry3(uint8 k, uint8 r5);
void BufferFileSelectText(void);
void BufferLoadingLetterTiles(void);
void BufferPalettesRoutines_IggyLarryPlatform(void);
void BufferPalettesRoutines_Levels(void);
void BufferPalettesRoutines_LoadColorInVerticalStrip(uint16 k, uint16 r4);
void BufferPalettesRoutines_LoadColors(const uint16 *r0, uint16 r4, uint16 r6, uint16 r8);
void BufferPalettesRoutines_Overworld(void);
void BufferPalettesRoutines_Overworld(void);
void BufferPalettesRoutines_ReznorAndMode7KoopaBosses(void);
void BufferPalettesRoutines_TitleScreen(void);
void ChangeNetDoorTiles(GenTileArgs *gta);
void CheckPowerUpSpecificPlayerAttacks(void);
void CheckIfBlockWasHit_Entry3(uint8 a, uint8 j);
void CheckIfBlockWasHit(uint8 a, uint8 j);
void CheckWhichControllersArePluggedIn(void);
void ClearLayer3Tilemap(void);
void ClearOutNormalSpriteSlots(void);
void ClearOverworldAndCutsceneRAM(void);
void CloseOwPrompt(void);
void CompressOamEntExt(void);
void DamagePlayer_00F622(void);
void DamagePlayer_DisableButtons(void);
void DamagePlayer_Hurt(void);
void DamagePlayer_Kill(void);
void DamagePlayer_KillAndDisableButtons(void);
void DamagePlayer_PitFall(void);
void DamagePlayer_SetHurtAnimationTimer(uint8 a);
void DisplayingContinueEnd(uint8 a);
void DisplayingContinueEnd(uint8 a);
uint16 DrawLoadingLetters_Draw(uint8 k, uint8 j, uint16 r0w);
void DrawLoadingLetters(void);
void EraseLargeSwitch(GenTileArgs *gta);
void EraseYoshiCoin(GenTileArgs *gta);
void FileSelectColorMath(uint16 a, uint8 j);
void GameMode00_LoadNintendoPresents_0093CA(void);
void GameMode00_LoadNintendoPresents_0093EA(uint8 k, uint8 j);
void GameMode00_LoadNintendoPresents(void);
void GameMode01_ShowNintendoPresents(void);
void GameMode04_PrepareTitleScreen(void);
void GameMode06_CircleEffect_009440(uint8 a);
void GameMode06_CircleEffect_009443(void);
void GameMode06_CircleEffect(void);
void GameMode07_TitleScreenDemo_FadeOutToTitleScreen(void);
void GameMode07_TitleScreenDemo_InitializeFileSelect(void);
void GameMode07_TitleScreenDemo_InitializeSaveData(void);
void GameMode07_TitleScreenDemo(void);
void GameMode08_FileSelect(void);
void GameMode08_FileSelect_SetStripeImage(uint8 j);
void GameMode09_EraseFile(void);
void GameMode0A_PlayerSelect_009E62(void);
void GameMode0A_PlayerSelect_Entry2(void);
void GameMode0A_PlayerSelect(void);
void GameMode0C_LoadOverworld(void);
void GameMode0E_ShowOverworld(void);
void GameMode10_BufferLevelLoadMessage(void);
void GameMode11_LoadSublevel_0096CF(uint8 j, uint8 a);
void GameMode11_LoadSublevel_00A796(void);
void GameMode11_LoadSublevel_GameMode03Entry(void);
void GameMode11_LoadSublevel_0096D5(void);
void GameMode12_PrepareLevel_00919B(void);
void GameMode12_PrepareLevel_009860(void);
void GameMode12_PrepareLevel_009A1F(uint8 k);
void GameMode12_PrepareLevel_009A3D(uint8 k);
void GameMode12_PrepareLevel(void);
void GameMode12_PrepareLevel_PrepareMode7Level(void);
void GameMode12_PrepareLevel_PrepareNonIggyLarryRoom(void);
void GameMode14_InLevel_0086C7(void);
void GameMode14_InLevel_00C47E(void);
void GameMode14_InLevel_HandlePlayerState(void);
void GameMode14_InLevel_InMode7Level(void);
void GameMode14_InLevel(void);
void GameMode14_InLevel_Return00C592(void);
void GameMode16_LoadDeathMessage(void);
void GameMode17_ShowDeathMessage(void);
void GameMode19_Cutscene_GameMode1BEntry(void);
void GameMode19_Cutscene(void);
void GameMode1D_LoadYoshisHouse_GameMode1FEntry(void);
void GameMode1D_LoadYoshisHouse(void);
void GameMode21_DelayEnemyRollcall(void);
void GameMode23_LoadEnemyRollcallScreen_00961E(void);
void GameMode23_LoadEnemyRollcallScreen_009622(uint8 k, uint8 j);
void GameMode23_LoadEnemyRollcallScreen(void);
void GameMode25_ShowEnemyRollcallScreen(void);
void GameMode27_LoadTheEnd(void);
void GameMode28_ShowTheEnd(void);
void GameMode29_DoNothingOnTheEndScreen(void);
void GameModeXX_FadeInOrOut_009F66(void);
void GameModeXX_FadeInOrOut_009F77(void);
void GameModeXX_FadeInOrOut_GMMosaic(void);
void GameModeXX_FadeInOrOut(void);
void GameModeXX_FadeInOrOut_MosaicFade(void);
void Gamemode_9_A_Common(void);
void GenerateTile_00BFBC(void);
void GenerateTile(void);
void GenericPage01Tile_00C0FB(GenTileArgs *gta, uint16 j);
void GenericPage01Tile(GenTileArgs *gta);
void GenericPage01Tile_Return00C1AB(void);
void GenericPage01Tile_SetItemMemory(GenTileArgs *gta);
int DecompressTo(const uint8 *src, uint8 *pdst);
void GraphicsDecompressionRoutines_DecompressGFX32And33(void);
uint8 *GraphicsDecompress(uint8 j);
void HandleMenuCursor_009E82(uint8 j);
void HandleMenuCursor_009ED4(uint8 k);
void HandlePaletteFades_00AF35(bool run_code_at_end);
uint16 HandlePaletteFades_00AFC0(uint16 a, uint16 r2, uint16 r12, uint16 r14);
void HandlePaletteFades(void);
void HandlePlayerLevelColl_00E98C(void);
void HandlePlayerLevelColl_00E9C8(uint8 j, uint8 cr);
void HandlePlayerLevelColl_00E9FB(void);
void HandlePlayerLevelColl_00EA08(void);
void HandlePlayerLevelColl_00EA0D(void);
void HandlePlayerLevelColl_00EA34(void);
void HandlePlayerLevelCollision(void);
void HandlePlayerPhysics_00D742(uint8 k, uint8 j);
void HandlePlayerPhysics_00D764(void);
void HandlePlayerPhysics_00D76B(void);
void HandlePlayerPhysics_00D772(uint8 k, uint8 j);
void HandlePlayerPhysics_00D94F(void);
void HandlePlayerPhysics_00DAA9(void);
void HandlePlayerPhysics_D930(uint8 j);
void HandlePlayerPhysics_Climbing(void);
void HandlePlayerPhysics_InAir(void);
void HandlePlayerPhysics(void);
void HandlePlayerPhysics_Swimming(void);
void HandlePlayerPhysics_UpdatePMeter(void);
uint8 HandlePlayerPhysics_UpdatePMeterEx(uint8 j);
void HandleSPCUploads_008134(void);
void HandleSPCUploads_StrtSPCMscUpld(const uint8 *p);
void HandleSPCUploads_UploadCreditsMusicBank(void);
void HandleSPCUploads_UploadDataToSPC(const uint8 *p);
void HandleSPCUploads_UploadOverworldMusicBank(void);
void HandleSPCUploads_UploadSPCEngine(void);
void HandleSPCUploads_UploadSamples(void);
void HandleStandardLevelCameraScroll_00F7F4(uint16 a);
uint16 HandleStandardLevelCameraScroll_00F8AB(uint16 r2w);
void HandleStandardLevelCameraScroll(void);
void IncrementSublevelsEnteredAndPrepareToLoadSublevel(void);
void InitAndMainLoop_ProcessGameMode(void);
void InitializeCapeSwingOrNetPunch(uint8 a);
void InitializeFirst8KBOfRAM(void);
void InitializeLevelLayer3_GenerateInteractiveTideWater(void);
void InitializeLevelLayer3(void);
void InitializeLevelRAM_00A6C7(uint8 k, uint8 j);
void InitializeLevelRAM_00A6CC(uint8 j);
void InitializeLevelRAM(void);
void InitializeLevelTileAnimations(void);
void InitializeSaveData(void);
void InitializeStatusBarTilemap(void);
void LoadSaveBufferData(void);
void LoadStripeImage(void);
void LoadStripeImage(void);
void LoadStripeImage_UploadToVRAM(const uint8 *pp);
void ManipulateMode7Image_008AE8(uint8 r0);
void ManipulateMode7Image(void);
void OwEventProcess04_FadeInLayer2Tile_00B006(uint8 a);
void PlayerGFXRt_00F636(uint8 r10, uint8 r11, uint8 r12, uint8 r13);
void PlayerDraw(void);
void PlayerState00_00B03E(void);
void PlayerState00_00C95B(void);
void PlayerState00_00C962(void);
void PlayerState00_00C96B(void);
void PlayerState00_LevelFinished(uint8 j, uint8 a);
void PlayerState00_00CA3E(void);
void PlayerState00_00CA44(void);
void PlayerState00_00CCE0(void);
void PlayerState00_00CD24(void);
void PlayerState00_00CD36(void);
void PlayerState00_00CD39(void);
void PlayerState00_00CD82(void);
void PlayerState00_00CD8B(void);
void PlayerState00_00CD8F(void);
void PlayerState00_00CD95(uint8 j);
void PlayerState00_00F8F2(void);
void PlayerState00_00F9C9(uint16 temp14b4, uint16 temp14b6, PointU16 pt);
void PlayerState00_CheckPlayerPitFall(void);
void PlayerState00_HandleEndOfLevel(void);
void PlayerState00_HandleLRScrolling(void);
void PlayerState00(void);
void PlayerState00_SetMarioPeaceImg(void);
void PlayerState00_SetMidpointFlag(void);
void PlayerState07_ShootOutOfPipe(void);
void PlayerState08_WarpToYoshiWingsBonus_00C845(void);
void PlayerState08_WarpToYoshiWingsBonus(void);
void PlayerState09_Death(void);
void PlayerState0A_NoYoshiCutscene_00C90A(void);
void PlayerState0A_NoYoshiCutscene(void);
void PlayerState0B_RescuedPeach(void);
void PlayerState0C_CastleDestructionMoves(void);
void PlayerStateXX_EnterPipe_00D1F4(void);
void PlayerStateXX_EnterPipe_00D22D(void);
void PlayerStateXX_EnterPipe_00D26A(void);
void PlayerStateXX_EnterPipe_Horizontal(void);
void PlayerStateXX_EnterPipe_Vertical(void);
void PlayerStateXX_PowerupAnims_Done(void);
void PlayerStateXX_PowerupAnims_GotCape(void);
void PlayerStateXX_PowerupAnims_GotFlower(void);
void PlayerStateXX_PowerupAnims_GrowAnimationEntry(void);
void PlayerStateXX_PowerupAnims_PowerDownEntry(void);
void PollJoypadInputs(void);
void ResetPlayerLevelCollisionRAM(void);
void RestoreSP1AfterMarioStart(void);
void RunPlayerBlockCode_00EB48(uint8 j);
void RunPlayerBlockCode_00EB73(void);
void RunPlayerBlockCode_00EE1D(void);
void RunPlayerBlockCode_00EE3A(void);
void RunPlayerBlockCode_00EE85(uint8 j);
void RunPlayerBlockCode_00EED1(uint8 j);
void RunPlayerBlockCode_00EEE1(uint8 j);
void RunPlayerBlockCode_00EFBC(void);
void RunPlayerBlockCode_00EFCD(uint8 k);
bool RunPlayerBlockCode_00EFE8_ReturnsTwice(uint8 k);
bool RunPlayerBlockCode_00F005_ReturnsTwice(uint8 j);
void RunPlayerBlockCode_00F28C(uint8 j);
void RunPlayerBlockCode_00F2C2(uint8 j, uint8 a);
void RunPlayerBlockCode_00F2C9(uint8 j, uint8 a);
void RunPlayerBlockCode_00F309(uint8 j);
void RunPlayerBlockCode_00F377(void);
void RunPlayerBlockCode_CheckIfEnteringHorizontalPipe(uint8 k, uint8 j, uint8 a);
void RunPlayerBlockCode_CheckIfGrabbingThrowBlock(uint8 j);
void RunPlayerBlockCode_CheckIfPlayerTouchingHurtBlock(uint8 a, uint8 j, bool ignore_yoshi);
void RunPlayerBlockCode_EB77(void);
void RunPlayerBlockCode(void);
void RunPlayerBlockCode_SpawnFlatPalaceSwitch(void);
void SaveGame(void);
void SetEnemyRollcallParallaxHDMA_Init(void);
void SetEnemyRollcallParallaxHDMA(void);
void SetItemMemoryBit(void);
void SetKeepGameModeActiveTimer_OneFrame(void);
void SetKeepGameModeActiveTimer_VariableFrames(uint8 a);
void SetMode7PPUPointersAndLayer1Scroll(void);
void SetPlayerPose_Entry2(void);
void SetPlayerPose_Entry3(uint8 a);
void SetPlayerPose_Entry4(uint8 a);
void SetPlayerPose(void);
void SetStandardPPUSettings(void);
void SetVisibleLayers(uint8 a, uint8 k, uint8 j);
void SetupHDMAWindowingEffects_0092A0(void);
void SetupHDMAWindowingEffects_0092A8(void);
void SetupHDMAWindowingEffects_ClearWindowTable(void);
void SetupHDMAWindowingEffects_EndHDMA(void);
void SetupHDMAWindowingEffects(void);
void SpawnGlitterEffectForCoin(void);
void SpawnMountedYoshiOnLevelLoad(void);
void SpawnPlayerBreathBubble(void);
void SpawnPlayerFireball(void);
void SpawnPlayerTurnAroundSmoke_00FE72(uint8 j);
void SpawnPlayerTurnAroundSmoke(void);
void SpawnPlayerWaterSplashAndBubbles(void);
void SpawnScoreSpriteAtPlayerPosition_LakituEntry(void);
void SpawnScoreSpriteAtPlayerPosition(uint8 a);
void Spr029_KoopaKids_Init_SetPosition(uint8 k);
void Spr07B_GoalTape_LvlEndPowerUp(uint8 j);
void Spr07B_GoalTape_TriggerGoalTape(void);
void Spr088_WingedCage_SyncLayer3ScrollToLayer1(uint8 k);
void Spr088_WingedCage_SyncPlayerPosToLayer1(void);
void Spr089_Layer3Smasher_UpdatePos(uint8 k);
void SprStatus06_GoalCoins(uint8 k);
void TurnOffIO(void);
void UnusedAddToWarpPipeTimerRoutine(void);
void UnusedYoshiRelatedRoutine(void);
void UpdateCurrentPlayerPositionRAM(void);
void UpdateEntirePalette(void);
void UpdateHDMAWindowBuffer_IrisInOnPlayerEntry(uint8 a, HdmaPtrs hptr);
void UpdateHDMAWindowBuffer_KeyholeEntry(HdmaPtrs hptr, uint8 r0, uint8 r1);
HdmaPtrs UpdateHDMAWindowBuffer_SetCircleHDMAPointer(void);
void UpdatePaletteFromIndexedTable_00AE47(void);
void UpdatePaletteFromIndexedTable(void);
void UpdatePlayerSpritePosition(void);
void UpdateStatusBarCounters_009051(uint8 k, uint8 j, uint16 r2w);
void UpdateStatusBarCounters_DrawItemBoxItem(void);
void UpdateStatusBarCounters_Loop2(uint8 k, uint8, uint16 r0w, uint16 r2w);
void UpdateStatusBarCounters(void);
void UploadBigLayer3LettersToVRAM(void);
void ConvertGFX27IntoNormallFormat(uint16 *dst);
void UploadGraphicsFiles_Layer3(void);
void UploadGraphicsFiles(void);
void UploadGraphicsFiles_UploadGFXFile(uint16 dst_addr, uint8 j, uint8 index);
void UploadLevelExAnimationData(void);
void UploadLevelAnimations_RedFlash(uint8 a, uint8 r0);
void UploadLevelAnimations_YellowFlash(uint8 a);
void UploadLevelLayer1And2Tilemaps(void);
void UploadLoadingLettersTiles(void);
void UploadMode7KoopaBossesAndLavaAnimation(void);
void UploadOAMBuffer(void);
void UploadOverworldExAnimationData(void);
void UploadOverworldLayer1And2Tilemaps(uint8 j);
void UploadPlayerGFX(void);
void UploadStatusBarTilemap(void);
void sub_9291(uint16 k);
void sub_9F4C(uint8 j);
void sub_C074(GenTileArgs *gta);
void sub_C077(GenTileArgs *gta);

// Bank 1
uint8 CheckAvailableExtendedSpriteSlot(uint8 k);
uint8 CheckNormalSpriteToNormalSpriteColl_01A77C_ReturnsTwice(uint8 k, uint8 j);
uint8 CheckPlayerToNormalSpriteColl_01A80F(uint8 k);
uint8 CheckPlayerToNormalSpriteColl_01A847(uint8 k);
uint8 CheckPlayerToNormalSpriteCollision(uint8 k);
uint8 CheckPlayerToNormalSpriteColl_ProcessInteract(uint8 k);
uint8 CheckPlayerToNormalSpriteColl_ReturnNoContact(void);
uint8 CheckPlayerToNormalSpriteColl_ReturnNoContact2(void);
CheckPlatformCollRet CheckTiltingPlatformCollision(uint16 temp14b4, uint16 temp14b6);
uint8 CheckIfNormalSpriteOffScreen(uint8 k);
uint8 CheckNormalSpriteLevelColl_Ceiling(uint8 k);
uint8 CheckNormalSpriteLevelColl_Floor(uint8 k);
uint8 CheckNormalSpriteLevelColl_Wall(uint8 k);
uint8 CheckPlayerPositionRelativeToSprite_Bank01_X(uint8 k);
uint8 CheckPlayerPositionRelativeToSprite_Bank01_Y(uint8 k);
uint8 FinishOAMWrite_01B844(uint16 r4w);
typedef struct GetDrawInfoRes {
  uint8 idx;
  uint8 x, y;
} GetDrawInfoRes;

GetDrawInfoRes GetDrawInfo_Bank01_ReturnsTwice(uint8 k);
uint8 GetRand(void);
uint8 GetRand_01AD07(uint8 j);
uint8 HandleNormalSpriteLevelColl_019441(uint8 k, uint8 j, PointU16 *pt_out);
uint8 HandleNormalSpriteLevelColl_01944D(uint8 k, uint8 j, PointU16 *pt_out);
uint8 HandleNormalSpriteLevelColl_019523(uint16 r5);
uint8 SolidSpriteBlock_Entry2(uint8 k);
uint8 SolidSpriteBlock(uint8 k);
uint8 Spr029_KoopaKid_MortonRoyLudwig_01D0C0(uint8 k);
uint8 Spr04C_ExplodingBlock_Init(uint8 k);
void Spr04C_ExplodingBlock_Init_MainV(uint8 k);
uint8 Spr05F_BrownChainedPlatform_01C9BF(uint16 r9);
uint8 Spr05F_BrownChainedPlatform_01CA9C(uint8 k, PointU16 pt);
CheckPlatformCollRet Spr0A7_IggyBall_CheckTiltingPlatformCollision(uint8 k);
uint8 SprXXX_Generic_Init_MakeSpriteFacePlayer(uint8 k);
void SprXXX_Generic_Init_MakeSpriteFacePlayerV(uint8 k);
uint8 SprXXX_LineGuided_01D94D(uint16 r0w, uint16 r2w);
uint8 SprXXX_SmallMontyMole_01E3EF_ReturnsTwice(uint8 k);
uint8 SprXXX_TurnBlockBridge_01B8FF(uint8 k, uint16 R0, uint16 r2);
uint8 sub_1B505(uint8 k);
uint8 sub_1EC50(void);
PointU8 AimTowardsPlayer_Bank01(uint8 k, uint8 a);
void BoostMarioSpeed(void);
void BreakThrowBlock(uint8 k);
void BreakThrowBlock_MontyMoleEntry(uint8 k, uint8 j);
uint32 CalculateCircleCoordinatesForTiltingPlaform_01CC28(uint16 R0_W_, uint16 R2_W_);
PointU16 CalculateCircleCoordinatesForTiltingPlaform(CalcTiltPlatformArgs inp);
void ChangeNormalSpriteDirection_CheckIfTouchingWall(uint8 k);
void ChangeNormalSpriteDirection_FlipXSpeedAndDirection(uint8 k);
void ChangeNormalSpriteDirection(uint8 k);
void CheckNormalSpriteToNormalSpriteColl_01A4BA(uint8 k, uint8 j);
void CheckNormalSpriteToNormalSpriteColl_01A5D3(uint8 j);
void CheckNormalSpriteToNormalSpriteColl_01A6D9(uint8 k, uint8 j);
void CheckNormalSpriteToNormalSpriteColl_01A755(uint8 k);
void CheckNormalSpriteToNormalSpriteColl_PlayKickSfx(void);
void CheckNormalSpriteToNormalSpriteCollision(uint8 k);
void CheckPlayerAndNormalSpriteCollisions(uint8 k);
void CheckPlayerToNormalSpriteColl_01A8D8(uint8 k);
void CheckPlayerToNormalSpriteColl_01AA0B(uint8 k);
void CheckPlayerToNormalSpriteColl_01AA42(uint8 k);
void CheckPlayerToNormalSpriteColl_01AB31(uint8 k);
void CheckPlayerToNormalSpriteColl_01AB46(uint8 k);
void CheckPlayerToNormalSpriteColl_SetStunnedTimer(uint8 k);
void CheckTiltingPlatformColl_01CCC7(void);
void CheckTiltingPlatformColl_Return01CCEA(void);
void CheckTiltingPlatformColl_Return01CCEB(void);
void DrawWingTiles_019E35(uint8 k, uint8 j);
void DrawWingTiles_019E37(uint8 k, uint8 r2);
void DrawWingTiles(uint8 k);
void DrawWingTiles_ParaKoopaEntry(uint8 k);
void FinishOAMWrite(uint8 k, uint8 j, uint8 a);
void FinishOAMWrite(uint8 k, uint8 j, uint8 a);
void GenericGFXRtDraw1Tile16x16_019F0F(uint8 k, uint8 r4);
void GenericGFXRtDraw1Tile16x16(uint8 k);
void GenericGFXRtDraw1Tile16x16_Sub(uint8 k, uint8 a);
void GenericGFXRtDraw1Tile16x16(uint8 k);
void GenericGFXRtDraw2Tiles16x16sStacked_019DA9(uint8 k, uint8 j, uint8 r0);
void GenericGFXRtDraw2Tiles16x16sStacked_Sub(uint8 k);
void GenericGFXRtDraw2Tiles16x16sStacked_UpsideDown(uint8 k);
void GenericGFXRtDraw4Tiles8x8Square_Entry1(uint8 k, uint8 a, uint8 j);
void GenericGFXRtDraw4Tiles8x8Square(uint8 k, uint8 a);
void GenericGFXRtMoveTileOffscreenVertically(uint8 k, uint8 j);
void GenericSmushedSpriteDraw(uint8 k);
void GetSineAndCosineOfTiltingPlatform(void);
void GivePlayerStarPower(void);
void HandleNormalSpriteGravity(uint8 k);
void HandleNormalSpriteLevelColl_019211(uint8 k);
void HandleNormalSpriteLevelColl_01928E(uint8 k, uint8 a);
void HandleNormalSpriteLevelColl_0192C9(uint8 k);
void HandleNormalSpriteLevelColl_019330(uint8 k);
void HandleNormalSpriteLevelColl_01933B(uint8 k, uint8 a, uint8 r10, uint8 r12, uint8 r15);
void HandleNormalSpriteLevelColl_019425(uint8 k, uint16 xpos_r10w, uint16 ypos_r12w, uint8 r15);
void HandleNormalSpriteLevelColl_019435(uint8 k, uint8 r15);
void HandleNormalSpriteLevelCollision(uint8 k);
void HandleNormalSpriteLevelCollision(uint8 k);
void KickHelplessSprite(uint8 k);
void KickedShellDraw(uint8 k);
void MakeLakituThrowSpiny(uint8 k);
void MakeLakituThrowSpiny(uint8 k);
void MakeNormalSpriteReboundOffWall(uint8 k);
void MakeStunnedSpriteBounceOrSlowDownOnGround(uint8 k);
void NormalSpritePlatformGFXRt_01B37E(uint8 k, uint8 a);
void NormalSpritePlatformGFXRt_DrawFlatPlatform(uint8 k);
void NormalSpritePlatformDraw(uint8 k);
void PlayerGFXRt_01EA70(void);
void PlayerGFXRt_01EA8F(uint8 k);
void PowerUpAndItemGFXRt_DrawCoinSprite(uint8 k);
void PowerUpAndItemGFXRt_DrawCoinSprite(uint8 k);
void PowerUpAndItemDraw(uint8 k);
void PrepareToHatchNormalSpriteYoshiEgg_Entry2(uint8 k);
void PrepareToHatchNormalSpriteYoshiEgg(uint8 k);
void ProcessNormalSprites_GetNormalSpriteOAMIndexAndDecrementTimers(uint8 k);
void ProcessNormalSprites_HandleSprite(uint8 k);
void ProcessNormalSprites(void);
void ProcessStunnedNormalSprite(uint8 k);
void ProcessStunnedNormalSprite_StunnedBabyYoshi_01A2B5(uint8 k);
void ProcessStunnedNormalSprite_StunnedBabyYoshi_01A2F4(uint8 k);
void ProcessStunnedNormalSprite_StunnedBabyYoshi_01A300(uint8 k);
void ProcessStunnedNormalSprite_StunnedBabyYoshi_01A30A(uint8 k);
void ProcessStunnedNormalSprite_StunnedBabyYoshi_01A34F(uint8 k);
void ProcessStunnedNormalSprite_StunnedFish(uint8 k);
void ProcessStunnedNormalSprite_StunnedGoomba(uint8 k);
void ProcessStunnedNormalSprite_StunnedMechaKoopa(uint8 k);
void ProcessStunnedNormalSprite_StunnedMechaKoopa_01A169(uint8 k);
void ProcessStunnedNormalSprite_StunnedThrowBlock(uint8 k);
void SetFacingDirectionBasedOnSpeed(uint8 k);
void SetNormalSpriteAnimationFrame(uint8 k);
void SetNormalSpriteYSpeedBasedOnSlope(uint8 k);
void SetXSpeedBasedOnNormalSpriteFacingDirection(uint8 k);
void SpawnContactEffectFromAbove(uint8 k);
void SpawnContactEffectFromSide(uint8 k);
void SpawnContactEffectFromSide_NoKickSound(uint8 k);
void SpawnNormalSpriteTurnAroundSmoke_Entry2(uint8 k, uint8 r0, uint8 r1);
void SpawnNormalSpriteTurnAroundSmoke(uint8 k);
void SpawnSparkles_GoalSphereEntry(uint8 k, uint8 a);
void SpawnSparklesSpriteEntry(uint8 k);
void Spr00E_Keyhole_Init(uint8 k);
void Spr00E_Keyhole(uint8 k);
void Spr010_ParaGoomba_018DAC(uint8 k);
void Spr010_ParaGoomba_GoombaWingDraw(uint8 k);
void Spr010_ParaGoomba(uint8 k);
void Spr012_Unused_Init(uint8 k);
void Spr012_Unused_Init_Return(uint8 k);
void Spr014_SpinyEgg(uint8 k);
void Spr016_VerticalCheepCheep_Init(uint8 k);
void Spr016_VerticalCheepCheep(uint8 k);
void Spr017_GeneratorCheepCheep_Init(uint8 k);
void Spr017_GeneratorCheepCheep(uint8 k);
void Spr018_SurfaceJumpingCheepCheep_01B209(uint8 k);
void Spr018_SurfaceJumpingCheepCheep(uint8 k);
void Spr019_DisplayMessage_Init(uint8 k);
void Spr01A_ClassicPiranhaPlant(uint8 k);
void Spr01C_BulletBill_Init(uint8 k);
void Spr01C_BulletBill(uint8 k);
void Spr01D_HoppingFlame_018F50(uint8 k);
void Spr01D_HoppingFlame(uint8 k);
void Spr01E_Lakitu_Init(uint8 k);
void Spr01E_Lakitu_Init_SetLakituType(uint8 k);
void Spr01F_MagiKoopa_Init(uint8 k);
void Spr01F_MagiKoopa_BE82(uint8 k, uint8 a);
void Spr01F_MagiKoopa_BE86(uint8 k, uint8 a);
void Spr01F_MagiKoopa_01BF1D(uint8 k);
bool Spr01F_MagiKoopa_01BFE3_ReturnsTwice(uint8 k);
void Spr01F_MagiKoopa_01C004(uint8 k);
void Spr01F_MagiKoopa_01C028(uint8 k);
void Spr01F_MagiKoopa(uint8 k);
void Spr01F_MagiKoopa_State00_FindOpenSpace(uint8 k);
void Spr01F_MagiKoopa_State01_FadeIn(uint8 k);
void Spr01F_MagiKoopa_State02_Shoot(uint8 k);
void Spr01F_MagiKoopa_State03_FadeOut(uint8 k);
void Spr020_Magic_01BD98(uint8 k);
void Spr020_Magic_Draw(uint8 k);
void Spr020_Magic(uint8 k);
void Spr026_Thwomp_Init(uint8 k);
void Spr026_Thwomp_Init_Return(uint8 k);
void Spr026_Thwomp_Falling(uint8 k);
void Spr026_Thwomp_Draw(uint8 k);
void Spr026_Thwomp(uint8 k);
void Spr026_Thwomp_Rising(uint8 k);
void Spr026_Thwomp_Waiting(uint8 k);
void Spr027_Thwimp(uint8 k);
void Spr029_KoopaKid_IggyLarry_01FC62(uint8 k, PointU16 pt);
PointU16 Spr029_KoopaKid_IggyLarry_01FD50(uint8 k);
void Spr029_KoopaKid_IggyLarry_Draw(uint8 k, PointU16 pt);
void Spr029_KoopaKid_IggyLarry_InShellDraw(uint8 k, PointU16 pt);
void Spr029_KoopaKid_IggyLarry(uint8 k);
void Spr029_KoopaKid_IggyLarry_ThrowBall(uint8 k, PointU16 pt);
void Spr029_KoopaKid_MortonRoyLudwig_01D309(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_01CE1E(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_01CE3E(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_01CFD0(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_01D059(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_01D2A8(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_01D351(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_01D3B1(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_01D40B(uint8 k, CollInfo *ci);
void Spr029_KoopaKid_MortonRoyLudwig_GetDrawInfo(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_ProcessLudwigsAttacks(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_ProcessRoysAttacks(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_State02(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_State03_Hurt(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_State04_Dying(uint8 k);
void Spr029_KoopaKid_MortonRoyLudwig_State05_ActivateLevelEnd(uint8 k);
void Spr029_KoopaKids_Init(uint8 k);
void Spr029_KoopaKids(uint8 k);
void Spr02B_SumoLightning(uint8 k);
void Spr02C_YoshiEgg_Init(uint8 k);
void Spr02C_YoshiEgg_01F7C8(uint8 k);
void Spr02C_YoshiEgg(uint8 k);
void Spr02F_PortableSpringboard_01E6F0(uint8 k);
void Spr02F_PortableSpringboard(uint8 k);
void Spr030_ThrowingDryBones_01E5C4(uint8 k);
void Spr031_BonyBeetle(uint8 k);
void Spr033_Podoboo_Init(uint8 k);
void Spr033_Podoboo_01E0E2(uint8 k);
void Spr033_Podoboo(uint8 k);
void Spr034_LudwigFireball(uint8 k);
void Spr035_Yoshi_Init(uint8 k);
void Spr035_Yoshi_Init_Return(uint8 k);
void Spr035_Yoshi_01EDCC(uint8 k);
void Spr035_Yoshi_01EDCE(uint8 k, uint8 j);
uint8 Spr035_Yoshi_01EF18(uint8 k);
void Spr035_Yoshi_01F0A2(uint8 k);
void Spr035_Yoshi_01F295(uint8 k, uint8 r0);
void Spr035_Yoshi_01F2DF(uint8 j);
void Spr035_Yoshi_01F309(void);
uint8 Spr035_Yoshi_01F3FE(uint8 k);
void Spr035_Yoshi_01F4B2(uint8 k, uint8 r13);
void Spr035_Yoshi_01F622(uint8 k);
void Spr035_Yoshi_01F668(uint8 k, uint8 j);
void Spr035_Yoshi_01F6CD(uint8 j);
void Spr035_Yoshi_HandleOffYoshi(uint8 k);
void Spr035_Yoshi_HandleYoshiSwallowingSomething(void);
void Spr035_Yoshi(uint8 k);
void Spr035_Yoshi_MouthState00(uint8 k);
void Spr035_Yoshi_MouthState01_ExtendTongue(uint8 k);
void Spr035_Yoshi_MouthState02_RetractTongue(uint8 k);
void Spr035_Yoshi_MouthState03_Spitting(uint8 k);
void Spr035_Yoshi_Return01F3FD(void);
void Spr035_Yoshi_TryEatSprite(uint8 k, uint8 j, CollInfo *ci);
void Spr03D_RipVanFish(uint8 k);
void Spr03E_PSwitch_Init(uint8 k);
void Spr03E_PSwitch(uint8 k);
void Spr03F_ParachuteGoomba(uint8 k);
void Spr044_TorpedoTed(uint8 k);
void Spr045_DirectionalCoins(uint8 k);
void Spr046_DigginChuck(uint8 k);
void Spr047_SwimmingAndJumpingCheepCheep(uint8 k);
void Spr048_DigginChuckRock(uint8 k);
void Spr049_ShiftingPipe_Init(uint8 k);
void Spr049_ShiftingPipe(uint8 k);
void Spr04A_GoalSphere(uint8 k);
void Spr04B_PipeLakitu(uint8 k);
void Spr04C_ExplodingBlock(uint8 k);
void Spr04E_LedgeMontyMole(uint8 k);
void Spr052_MovingLedgeHole_Init(uint8 k);
void Spr054_ClimbingNetDoor_Init(uint8 k);
void Spr054_ClimbingNetDoor_01BC1D(CollInfo *ci);
void Spr054_ClimbingNetDoor(uint8 k);
void Spr057_VerticalCheckerboardPlatform_Init(uint8 k);
void Spr058_VerticalRockPlatform(uint8 k);
void Spr05F_BrownChainedPlatform_Init(uint8 k);
void Spr05F_BrownChainedPlatform_01C9E2(uint8 k);
CalcTiltPlatformArgs Spr05F_BrownChainedPlatform_01CACB(uint8 k);
void Spr05F_BrownChainedPlatform(uint8 k);
void Spr05F_BrownChainedPlatform_UpdateAngle(uint8 k);
void Spr060_FlatPalaceSwitch_Init(uint8 k);
void Spr060_FlatPalaceSwitch(uint8 k);
void Spr061_SkullRaft_Init(uint8 k);
void Spr061_SkullRaft(uint8 k);
void Spr06A_CoinGameCloud(uint8 k);
void Spr06C_RightWallSpringboard_Init(uint8 k);
void Spr06E_DinoRhino_Init(uint8 k);
void Spr06E_DinoRhino(uint8 k);
void Spr06F_DinoTorch_Init_01855D(uint8 k);
void Spr070_Pokey_Init(uint8 k);
void Spr070_Pokey(uint8 k);
void Spr071_RedCapeSuperKoopa_Init(uint8 k);
void Spr073_GroundSuperKoopa_Init(uint8 k);
void Spr076_Star_Init(uint8 k);
void Spr077_Feather(uint8 k);
void Spr079_VineHead(uint8 k);
void Spr07B_GoalTape_Init_01C062(uint8 k);
void Spr07B_GoalTape_Init(uint8 k);
void Spr07B_GoalTape_Draw(uint8 k);
void Spr07B_GoalTape(uint8 k);
void Spr080_Key_Init(uint8 k);
void Spr080_Key(uint8 k);
void Spr081_ChangingItem_Init(uint8 k);
void Spr081_ChangingItem_Init_Return(uint8 k);
void Spr082_BonusGame_Init(uint8 k);
void Spr082_BonusGame_01DF19(uint8 k);
void Spr082_BonusGame_01DFD9(void);
void Spr082_BonusGame_01E281(void);
void Spr082_BonusGame(uint8 k);
void Spr082_BonusGame_Spawn1ups(void);
void Spr083_LeftFlyingBlock(uint8 k);
void Spr085_Unused(uint8 k);
void Spr086_Wiggler_Init(uint8 k);
void Spr086_Wiggler(uint8 k);
void Spr087_LakituCloud_01E98D(uint8 k);
void Spr087_LakituCloud_Draw(uint8 k);
void Spr087_LakituCloud(uint8 k);
void Spr088_WingedCage_Init(uint8 k);
void Spr088_WingedCage(uint8 k);
void Spr089_Layer3Smasher(uint8 k);
void Spr08A_Bird(uint8 k);
void Spr08B_FireplaceSmoke(uint8 k);
void Spr08C_SideExitAndFireplace(uint8 k);
void Spr08D_GhostHouseDoor(uint8 k);
void Spr08E_WarpHole(uint8 k);
void Spr08F_ScalePlatform_Init(uint8 k);
void Spr08F_ScalePlatform(uint8 k);
void Spr090_GreenGasBubble(uint8 k);
void Spr091_CharginChuck_Init(uint8 k);
void Spr095_ClappinChuck_Init_BouncinChuckEntry(uint8 k);
void Spr095_ClappinChuck_Init_ChuckEntry_Comon(uint8 k, uint8 a);
void Spr095_ClappinChuck_Init_DigginChuckEntry(uint8 k);
void Spr095_ClappinChuck_Init(uint8 k);
void Spr095_ClappinChuck_Init_PitchinChuckEntry(uint8 k);
void Spr095_ClappinChuck_Init_PuntinChuckEntry(uint8 k);
void Spr095_ClappinChuck_Init_WhistlinChuckEntry(uint8 k);
void Spr046_DigginChuck(uint8 k);
void Spr099_VolcanoLotus(uint8 k);
void Spr09A_SumoBro_Init(uint8 k);
void Spr09A_SumoBro(uint8 k);
void Spr09B_HammerBro_Init(uint8 k);
void Spr09B_HammerBro(uint8 k);
void Spr09C_HammerBroPlatform(uint8 k);
void Spr09D_BubbleWithSprite_Init(uint8 k);
void Spr09D_BubbleWithSprite(uint8 k);
void Spr09E_BallNChain_Init_GreyChainedPlatformEntry(uint8 k);
void Spr09E_BallNChain_Init(uint8 k);
void Spr09E_BallNChain(uint8 k);
void Spr09F_BanzaiBill_Init(uint8 k);
void Spr0A5_Sparky(uint8 k);
void Spr0A7_IggyBall(uint8 k);
void Spr0A9_Reznor_Init(uint8 k);
void Spr0AA_Fishbone_Init(uint8 k);
void HandleExtraSprites(uint8 k);
void Spr0AC_DownFirstWoodenSpike_Init(uint8 k);
void Spr0AD_UpDownFirstWoodenSpike_Init(uint8 k);
void Spr0B1_CreateEatBlock_Init(uint8 k);
void Spr0B3_BowserStatueFire_Init(uint8 k);
void Spr0B4_NonLineGuideGrinder_Draw(uint8 k);
void Spr0B4_NonLineGuideGrinder(uint8 k);
void Spr0BA_TimedPlatform_Init(uint8 k);
void Spr0BC_BowserStatue_Init(uint8 k);
void Spr0BD_SlidingNakedBlueKoopa_Init(uint8 k);
void Spr0C0_SinkingLavaPlatform_Init(uint8 k);
void Spr0C0_SinkingLavaPlatform_Init_Return(uint8 k);
void SprStatus00_EmptySlot(uint8 k);
void SprStatus00_EmptySlot_Return(uint8 k);
void SprStatus01_Init(uint8 k);
void SprStatus02_Dead_019AD6(uint8 k);
void SprStatus02_Dead_HandleGenericSpriteDeath(uint8 k, uint8 j);
void SprStatus02_Dead(uint8 k);
void SprStatus02_Dead_SetNorSprStatus04(uint8 k);
void SprStatus02_Dead_Status05Entry(uint8 k);
void SprStatus03_Smushed(uint8 k);
void SubOffscreen_Bank01_EraseSprite(uint8 k);
void SprStatus04_SpinJumpKill(uint8 k);
void SprStatus08(uint8 k);
void SprStatus08_Return(uint8 k);
void SprStatus09_Stunned_BulletBillEntry(uint8 k);
void SprStatus09_Stunned_019554(uint8 k, uint8 a);
void SprStatus09_Stunned_01956A(uint8 k);
void SprStatus09_Stunned_019624(uint8 k);
void SprStatus09_Stunned(uint8 k);
void SprStatus09_Stunned_SetNormalStatus2(uint8 k);
void SprStatus0A_Kicked_0198A9(uint8 k);
void SprStatus0A_Kicked_01998C(uint8 k);
void SprStatus0A_Kicked_01998F(uint8 k);
void SprStatus0A_Kicked(uint8 k);
void SprStatus0B_Carried_019F9B(uint8 k);
void SprStatus0B_Carried_01A0B1(uint8 k);
void SprStatus0B_Carried(uint8 k);
void SprStatus0C_GoalPowerUp(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_Init_BuoyantCheckboardPlatformEntry(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_Init_01B262(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_Init_FloatingOrangePlatformEntry(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_Init_HorizontalTurnBlockBridgeEntry(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_Init_InitFloatingPlat(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_Init_Return(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_Init_SpikeBallEntry(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_01B563(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_FloatingOrangePlatformEntry(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_SpikeBallEntry(uint8 k);
void SprXXX_BuoyantPlatformsAndMine_SpikeBallDraw(uint8 k);
void SprXXX_Dolphins(uint8 k);
void SprXXX_Eeries_Init(uint8 k);
void SprXXX_Eeries_Init_SetInitialFrameCounter(uint8 k);
void SprXXX_Eeries(uint8 k);
void SprXXX_FixedMovementCheepCheep_Init_Return(uint8 k);
void SprXXX_FixedMovementCheepCheep_01B10A(uint8 k);
void SprXXX_Generic_Init(uint8 k);
void SprXXX_Generic_Init_Return(uint8 k);
void SprXXX_Generic_Init_StandardSpritesInit(uint8 k);
void SprXXX_Generic_BobOmbEntry(uint8 k);
void SprXXX_Generic_018908(uint8 k);
void SprXXX_Generic_018913(uint8 k);
void SprXXX_Generic_018931(uint8 k);
void SprXXX_Generic_018952(uint8 k);
void SprXXX_Generic_018B43(uint8 k);
void SprXXX_Generic_018CB7(uint8 k);
void SprXXX_Generic_018CC6(uint8 k);
void SprXXX_Generic_ExplodeBomb(uint8 k);
void SprXXX_Generic_GreenParaKoopaEntry(uint8 k);
void SprXXX_Generic_HorizontalRedParaKoopaEntry(uint8 k);
void SprXXX_Generic_JumpOverKickedObject(uint8 k);
void SprXXX_Generic_NakedKoopaEntry(uint8 k);
void SprXXX_Generic_SpinyEntry(uint8 k);
void SprXXX_Generic_Spr0to13Gfx(uint8 k);
void SprXXX_Generic_Spr0to13Main(uint8 k);
void SprXXX_Generic_VerticalRedParaKoopaEntry(uint8 k);
void SprXXX_LineGuided_Init_BrownLineGuidePlatformEntry(uint8 k);
void SprXXX_LineGuided_Init_ChainsawEntry(uint8 k);
void SprXXX_LineGuided_Init_CheckerboardLineGuidePlatformEntry(uint8 k);
void SprXXX_LineGuided_Init_LineGuideRopeEntry(uint8 k);
void SprXXX_LineGuided_01D74D(uint8 k);
void SprXXX_LineGuided_01D7B0(uint8 k, uint8 j);
void SprXXX_LineGuided_01DA90(uint8 a);
void SprXXX_LineGuided_01DBD4(uint8 k);
void SprXXX_LineGuided_01DC0B(uint8 k);
void SprXXX_LineGuided_01DC54(uint8 k);
void SprXXX_LineGuided_ChainsawEntry(uint8 k);
void SprXXX_LineGuided_LineFuzzyPlats(uint8 k);
void SprXXX_LineGuided_LineGuideGrinderEntry(uint8 k);
void SprXXX_LineGuided_State00_AtEndOfTile(uint8 k);
void SprXXX_LineGuided_State01_OnLineGuide(uint8 k);
void SprXXX_LineGuided_State02_Falling(uint8 k);
void SprXXX_NetKoopas_Init_01B950(uint8 k);
void SprXXX_NetKoopas_Init_HorizontalNetKoopaEntry(uint8 k);
void SprXXX_NetKoopas_Init_VerticalNetKoopaEntry(uint8 k);
void SprXXX_NetKoopas_01BA7F(uint8 k);
void SprXXX_NetKoopas(uint8 k);
void SprXXX_NonBossBoos_BigBooEntry(uint8 k);
void SprXXX_NonBossBoos_BooEntry(uint8 k);
void SprXXX_ParachutingEnemy_Return(uint8 k);
void SprXXX_PowerUps_01C4AC(uint8 k);
void SprXXX_PowerUps_01C4BF(uint8 k);
void SprXXX_PowerUps_01C4F0(uint8 k);
void SprXXX_PowerUps_01C538(uint8 k, uint8 a);
void SprXXX_PowerUps_01C56F(uint8 k);
void SprXXX_PowerUps_01C5AE(void);
void SprXXX_PowerUps_ChangingItemEntry(uint8 k);
void SprXXX_PowerUps_FireFlowerEntry(uint8 k);
void SprXXX_PowerUps_GiveMario1Up(uint8 k);
void SprXXX_PowerUps_GiveMarioCape(uint8 k);
void SprXXX_PowerUps_GiveMarioFire(uint8 k);
void SprXXX_PowerUps_GiveMarioMushroom(uint8 k);
void SprXXX_PowerUps_GiveMarioStar(uint8 k);
void SprXXX_PowerUps_Return01C560(void);
void SprXXX_PowerUps_StarEntry(uint8 k);
void SprXXX_ReflectingEnemy_Init(uint8 k);
void SprXXX_RegularPiranhaPlant_Init(uint8 k);
void SprXXX_RegularPiranhaPlant_Init_ShiftSpriteDown(uint8 k);
void SprXXX_SmallMontyMole_State00_Invisible(uint8 k);
void SprXXX_SmallMontyMole_State01_AboutToEmerge(uint8 k);
void SprXXX_SmallMontyMole_State02_PopOutOfGround(uint8 k);
void SprXXX_SmallMontyMole_State03_Walking(uint8 k);
void SprXXX_TurnBlockBridge_01B6B2(uint8 k);
void SprXXX_TurnBlockBridge_01B6E7(uint8 k);
void SprXXX_TurnBlockBridge_01B852(uint8 k, uint16 t);
uint16 SprXXX_TurnBlockBridge_Draw(uint8 k);
void SprXXX_TurnBlockBridge_HorizontalAndVerticalTurnBlockBridgeEntry(uint8 k);
void SprXXX_TurnBlockBridge_HorizontalTurnBlockBridgeEntry(uint8 k);
void SprXXX_TurnBlockBridge_Return01B851(void);
void SprXXX_WallFollowers_Init_01841B(uint8 k);
void SprXXX_WallFollowers_Init_01841D(uint8 k, uint8 a);
void SprXXX_WallFollowers_Init_RipVanFishEntry(uint8 k);
void SprXXX_WallFollowers_Init_SparkyEntry(uint8 k);
void SprXXX_WallFollowers_Init_SparkyEntry2(uint8 k);
void SprXXX_WallFollowers_Init_SpikeTopEntry(uint8 k);
void SprXXX_WallFollowers_Init_WallFollowUrchinEntry(uint8 k);
void SprXXX_WallSpringboard(uint8 k);
void StunnedShellGFXRt_01980F(uint8 k, uint8 a);
void StunnedShellDraw(uint8 k);
void SubOffscreen_Bank01_01AC2D(uint8 k, uint8 a);
void SubOffscreen_Bank01_01AC33(uint8 k, uint8 r3);
void SubOffscreen_Bank01_Entry1(uint8 k);
void SubOffscreen_Bank01_Entry2(uint8 k);
void SubOffscreen_Bank01_Entry3(uint8 k);
void SubOffscreen_Bank01_Entry4(uint8 k);
void sub_1891F(uint8 k);
void sub_1A5DA(void);
void sub_1A625(uint8 k, uint8 j);
void sub_1A642(uint8 k, uint8 j);
void sub_1A64A(uint8 k, uint8 j);
void sub_1A685(uint8 k, uint8 j);
void sub_1A72E(uint8 k, uint8 j);
void sub_1C9DA(uint8 k);
void sub_1C9EC(uint8 k, PointU16 pt);
void sub_1D31E(uint8 k);
void sub_1D334(uint8 k);
void sub_1F8E1(uint8 k, uint8 a);

// Bank 2
uint8 CheckAvailableScoreSpriteSlot(void);
uint8 CheckPlayerPositionRelativeToSprite_Bank23_X(uint8 k);
uint8 CheckPlayerPositionRelativeToSprite_Bank23_Y(uint8 k);
uint8 ExtSpr04_Hammer_ThrownBoneEntry(uint8 k);
uint8 FindFreeNormalSpriteSlot_02A9E6(uint8 r14);
uint8 FindFreeNormalSpriteSlot_HighPriority(void);
uint8 FindFreeNormalSpriteSlot_LowPriority(void);
uint8 FindFreeNormalSpriteSlot_02A9E6(uint8 r14);
GetDrawInfoRes GetDrawInfo_Bank23_ReturnsTwice(uint8 k);
uint8 GrabThrowBlockBlock(void);

typedef struct ExtCollOut {
  uint8 r10, r11, r12, r13;
} ExtCollOut;

uint8 HandleExtendedSpriteLevelColl_02A611(uint8 k, uint8 r15, ExtCollOut *out);
uint8 HandleExtendedSpriteLevelCollision(uint8 k, ExtCollOut *out);
uint8 InitializeBlockPunchAttack(void);
uint8 Spr08F_ScalePlatform_02E524(uint8 k, uint8 j);
uint8 Spr0A3_GreyChainedPlatform_02D870(uint8 k, uint8 a);
uint8 UpdateNormalSpritePosition_X(uint8 k);
uint8 UpdateNormalSpritePosition_Y(uint8 k);
PointU8 AimTowardsPlayer_Bank23(uint8 k, uint8 a);
void BobOmbExplosion_ExplodeKillSpr(uint8 k, uint8 j);
void BobOmbExplosion_ExplodeSprites(uint8 k);
void BobOmbExplosion(uint8 k);
void BobOmbExplosion(uint8 k);
void BounceSpr01_TurnBlock(uint8 k);
void BounceSpr07_SpinningTurnBlock(uint8 k);
void BounceSpriteDraw(uint8 k);
void CheckBerryTileCollisionWithYoshiTongue(CollInfo *ci);
void CheckMarioToExtendedSpriteColl_02A469(uint8 k);
void CheckMarioToExtendedSpriteColl_02A4DE(uint8 k);
void CheckMarioToExtendedSpriteColl_LoseYoshi(void);
void CheckMarioToExtendedSpriteCollision(uint8 k);
void CheckPlayerAttackToNormalSpriteColl_029404(uint8 k, uint8 r14);
void CheckPlayerAttackToNormalSpriteColl_CapeSwingEntry(uint8 r14);
void CheckPlayerAttackToNormalSpriteColl_GetBounceSpriteClipping(uint8 j, CollInfo *ci);
void CheckPlayerAttackToNormalSpriteColl_GetCapeSwingOrNetPunchClipping(CollInfo *ci);
void CheckPlayerAttackToNormalSpriteCollision(uint8 k);
void CheckPlayerFireballToNormalSpriteColl_GetPlayerFireballClipping(uint8 j, CollInfo *ci);
void CheckPlayerFireballToNormalSpriteCollision(uint8 k);
void CheckPlayerToEnemyClusterSpriteCollision(uint8 k);
void CheckPlayerToNormalSpriteColl_02B9D9(uint8 j);
void CheckPlayerToNormalSpriteColl_SpawnFeatherFromSuperKoopa(uint8 k);
void CheckPlayerToNormalSpriteColl_TurnSpritesIntoSilverCoins(void);
void CheckIfBabyYoshiCanEatNormalSprite_02EA8A(uint8 k, uint8 j);
void CheckIfBabyYoshiCanEatNormalSprite1(uint8 k);
void CheckIfBabyYoshiCanEatNormalSprite2(uint8 k);
void ClusterSpr01_1up(uint8 k);
void ClusterSpr01_1up_SpawnScoreSprite(uint8 k);
void ClusterSpr03_BooCeiling_02FC8D(uint8 k);
void ClusterSpr03_BooCeiling_02FCE2(uint8 k);
void ClusterSpr03_BooCeiling_DrawClusterSpriteBoo(uint8 k, uint8 a);
void ClusterSpr03_BooCeiling(uint8 k);
void ClusterSpr04_BooRing_02FBB0(uint8 k);
void ClusterSpr04_BooRing(uint8 k);
void ClusterSpr05_CandleFlame(uint8 k);
void ClusterSpr06_SumoBroFlame_02F940(uint8 k);
void ClusterSpr06_SumoBroFlame_02F9A6(uint8 k);
void ClusterSpr06_SumoBroFlame_02F9F5(void);
void ClusterSpr06_SumoBroFlame_CheckPlayerContact(uint8 k);
void ClusterSpr06_SumoBroFlame(uint8 k);
void ClusterSpr07_ReappearingBoo(uint8 k);
void DrawBigCastleGate_DrawBigCastleGate(uint8 r0);
void DrawBigCastleGate(void);
void DrawGhostHouseEntranceDoor(void);
void DrawGhostHouseEntranceDoor(void);
void DrawNoYoshiSign(void);
void DrawNoYoshiSign(void);
void DropReservedItem(void);
void ExtSpr01_SmokePuff(uint8 k);
void ExtSpr02_ReznorFireball(uint8 k);
void ExtSpr02_ReznorFireball_PiranhaFireballEntry(uint8 k);
void ExtSpr03_FlameRemnant(uint8 k);
void ExtSpr04_Hammer(uint8 k);
void ExtSpr05_MarioFireball_02A04F(uint8 k);
void ExtSpr05_MarioFireball_02A02C(uint8 k);
void ExtSpr05_MarioFireball_02A045(uint8 k);
void ExtSpr05_MarioFireball(uint8 k);
void ExtSpr07_LavaSplash(uint8 k);
void EraseExtSprite(uint8 k);
void ExtSpr08_LauncherArm(uint8 k);
void ExtSpr09_Unused(uint8 k);
void ExtSpr0A_CloudCoin_029D45(uint8 j, uint8 r1);
void ExtSpr0A_CloudCoin_029D36(uint8 j, uint8 a);
void ExtSpr0A_CloudCoin(uint8 k);
void ExtSpr0C_VolcanoLotusFire(uint8 k);
void ExtSpr0D_Baseball(uint8 k);
void ExtSpr0F_SmokeTrail(uint8 k);
void ExtSpr10_SpinJumpStars(uint8 k);
void ExtSpr11_YoshiFireball(uint8 k);
void ExtSpr12_BreathBubble(uint8 k);
void GameMode14_InLevel_Bank02(void);
void GameMode14_InLevel_02827D(void);
void GameMode14_InLevel_0283CE(void);
void GameMode14_InLevel_0283F8(uint8 k);
void GameMode14_InLevel_028439(uint8 k, uint8 xpos);
void GenSpr01_GenerateEerie(void);
void GenSpr02_GenParachuteEnemy(void);
void GenSpr07_GenerateFish(void);
void GenSpr08_TurnOffRespawningSprite(void);
void GenSpr09_GenerateSuperKoopa(void);
void GenSpr0A_GenerateBubbles(void);
void GenSpr0B_GenerateBullet(void);
void GenSpr0C_GenerateSurroundingBullets(uint8 r13);
void GenSpr0D_GenerateDiagnalBullets(void);
void GenSpr0E_GenerateFire(void);
void GenSpr0F_TurnOffGenerator(void);
void GenSprXX_GenerateDolphins(void);
uint8 GenericExtendedSpriteGFXRt_FireballEntry(uint8 k, uint8 j);
uint8 GenericExtendedSpriteDraw(uint8 k);
void GetBounceSpriteLevelCollisionMap16ID_029356(uint8 k);
void GetBounceSpriteLevelCollisionMap16ID(uint8 k);
void GetExtendedSpriteClipping(uint8 k, CollInfo *ci);
void GivePoints_02ACEF(uint8 k, uint8 a);
void GivePoints_Entry2(uint8 j, uint8 a);
void GivePoints(uint8 k, uint8 a);
void HandleCapeInteraction(void);
void HandleCapeLevelColl_029540(uint8 r15);
void HandleCapeLevelCollision(void);
void HandleCapeToExtendedSpriteCollision(void);
void HandleHeldPBalloonAndInLakituCloudMovement(uint8 k);
void InitializeAllSpritesOnLevelLoad(void);
void LoadSpritesOnLevelLoad(void);
void LoadSublevel_02A751(void);
void MExtSpr01_BrickPiece(uint8 k);
void MExtSpr02_SmallStar(uint8 k);
void MExtSpr03_EggShell(uint8 k);
void MExtSpr04_PodobooFire(uint8 k);
void MExtSpr06_RipVanFishZ(uint8 k);
void MExtSpr07_WaterSplash(uint8 k);
void MExtSpr0A_BooStream(uint8 k);
void MExtSpr0B_UnusedYoshiSmoke(uint8 k);
void MExtSpr_Delete(uint8 k);
void ParseLevelSpriteList_Entry2(void);
bool LoadOneSprite(const uint8 *p, uint8 k, PointU16 pt);
void ParseLevelSpriteList_LoadSpriteLoopStrt(uint8 k, uint8 j, PointU16 pt);
void ParseLevelSpriteList(void);
void ProcessBounceAndSmokeSprites_BounceSprites(uint8 k);
void ProcessBounceAndSmokeSprites(void);
void ProcessBounceAndSmokeSprites_Return02904C(uint8 k);
void ProcessBounceAndSmokeSprites_Return0296D7(uint8 k);
void ProcessBounceAndSmokeSprites_SmokeSprites(uint8 k);
void ProcessClusterSprites_02F821(uint8 k, uint8 a);
void ProcessClusterSprites();
void ProcessClusterSprites_Return02F820(uint8 k);
void ProcessExtendedSprites_029B16(uint8 k);
void ProcessExtendedSprites(void);
void ProcessExtendedSprites_Return029B15(uint8 k);
void ProcessGeneratorSprite(void);
void ProcessMinorExtendedSprites_028B94(uint8 k, uint8 a);
void ProcessMinorExtendedSprites(void);
void ProcessMinorExtendedSprites_Return(uint8 k);
void ProcessScoreSprites(void);
void ProcessScoreSprites_Sub(uint8 k);
void ProcessShooterSprites_02B3AB(uint8 k, uint8 a);
void ProcessShooterSprites(void);
void ProcessShooterSprites_Return02B3AA(uint8 k);
void ProcessSpinningCoinSprites_029ADA(uint8 k);
void ProcessSpinningCoinSprites(void);
void ProcessSpinningCoinSprites_Sub(uint8 k);
void ProcessSpinningCoinSprites_UpdateSpinningCoinSpriteYPosition(uint8 k);
void RunPlayerBlockCode_TriggerCapeDiveGroundPound(void);
void SetBabyYoshiDynamicGraphicsPointer(uint8 k);
void SetNormalSpriteYSpeedBasedOnSlope(uint8 k);
void ShatterExplodingBlock(uint8 k);
void ShooterSpr01_BulletBillShooter(uint8 k);
void ShooterSpr01_BulletBillShooter_ShowShooterSmoke(uint8 k);
void ShooterSpr02_TorpedoShooter(uint8 k);
void EraseSmokeSprite(uint8 k);
void SmokeSpr01_PuffOfSmoke(uint8 k);
void EraseSmokeSprite(uint8 k);
void SmokeSpr02_ContactEffect(uint8 k);
void SmokeSpr03_TurnAroundSmoke(uint8 k);
void SmokeSpr05_Glitter(uint8 k);
void SpawnBounceSprite_02887D(uint8 r5);
void SpawnBounceSprite(uint8 r4, uint8 r5, uint8 r6, uint8 r7);
void SpawnBounceSprite_SpawnSpinningCoins(void);
void SpawnBrickPieces(uint8 a);
void SpawnLavaSplash(uint8 k);
void SpawnMap16TileFromBounceSprite_InvisibleSolidBlock(uint8 k);
void SpawnMap16TileFromBounceSprite(uint8 k, uint8 a);
void SpawnMap16TileFromBounceSprite_MultiCoinBlock(uint8 k);
void SpawnMusicNoteOrZ_02C0DB(uint8 k, uint8 a);
void SpawnMusicNoteOrZ_MusicNote(uint8 k);
void SpawnMusicNoteOrZ_Z(uint8 k);
void SpawnSmokePuff(void);
void SpawnSparkles(uint8 r0, uint8 r2);
void SpawnSparkles_PlayerEntry(void);
void SpawnWaterSplash_0284C2(uint8 k, uint8 a);
void SpawnWaterSplash_0284D8(uint8 k, uint8 r0, uint8 r2);
void SpawnWaterSplash(uint8 k);
void SpawnWaterSplash_VerticalCheepCheepEntry(uint8 k);
void SpawnYoshiStompSmoke(void);
void SpawnYoshiStompSmoke_SpawnFirstSmoke(uint8 r0);
void Spr01E_Lakitu(uint8 k);
void Spr01E_Lakitu_LakituFishingLineDraw(uint8 k);
void Spr02B_SumoLightning(uint8 k);
void Spr02B_SumoLightning_02DF2C(uint8 k);
void Spr033_Podoboo_SpawnPodobooFire(uint8 k);
void Spr035_Yoshi_028BC0(uint8 k, uint8 r0);
void Spr035_Yoshi_02D0E6(uint8 k);
void Spr035_Yoshi_ChangeBerryIntoBushTile(void);
void Spr035_Yoshi_CheckBerryTileCollisionWithAdultYoshiMouth(uint8 k);
void Spr035_Yoshi_DrawYoshisWings(uint8 k, uint8 a);
void Spr035_Yoshi_SpawnUnusedYoshiSmoke(uint8 k);
void Spr035_Yoshi_SpawnUnusedYoshiSmoke_Return(uint8 k);
void Spr035_Yoshi_Sub(uint8 k);
void Spr03D_RipVanFish(uint8 k);
void Spr03D_RipVanFish_SetFacingDirectionBasedOnSpeed(uint8 k);
void Spr044_TorpedoTed(uint8 k);
void Spr044_TorpedoTed_Draw(uint8 k);
void Spr044_TorpedoTed_SpawnSmokePuffTrail(uint8 k);
void Spr045_DirectionalCoins(uint8 k);
void Spr045_DirectionalCoins_02E271(uint8 k);
void Spr047_SwimmingAndJumpingCheepCheep(uint8 k);
void Spr047_SwimmingAndJumpingCheepCheep_Jumping(uint8 k);
void Spr047_SwimmingAndJumpingCheepCheep_Swimming(uint8 k);
void Spr048_DigginChuckRock(uint8 k);
void Spr049_ShiftingPipe(uint8 k);
void Spr049_ShiftingPipe_Draw(uint8 k);
void Spr049_ShiftingPipe_GrowingPipeGfx(uint8 k, uint8 j);
void Spr04B_PipeLakitu(uint8 k);
void Spr04B_PipeLakitu_Draw(uint8 k);
void Spr04C_ExplodingBlock(uint8 k);
void Spr052_MovingLedgeHole_02E5F7(uint8 k);
void Spr052_MovingLedgeHole_Draw(uint8 k);
void Spr052_MovingLedgeHole(uint8 k);
void Spr060_FlatPalaceSwitch_Sub(uint8 k);
void Spr061_SkullRaft_Init(uint8 k);
void Spr061_SkullRaft_Init(uint8 k);
void Spr061_SkullRaft(uint8 k);
void Spr061_SkullRaft(uint8 k);
void Spr06A_CoinGameCloud(uint8 k);
void Spr06A_CoinGameCloud_02EF67(uint8 k);
void Spr06A_CoinGameCloud(uint8 k);
void Spr070_Pokey(uint8 k);
void Spr070_Pokey_Bank02SpriteEntry(uint8 k, uint8 j, uint8 a);
void Spr070_Pokey_02B7AC(uint8 k);
void Spr070_Pokey_02B82E(uint8 k, uint8 r13);
uint8 Spr070_Pokey_RemovePokeySegment(uint8 k, uint8 a);
void Spr070_Pokey_Sub(uint8 k);
void Spr086_Wiggler_Init(uint8 k);
void Spr086_Wiggler_Init_GetWigglerSegmentPosIndex(uint8 k);
void Spr086_Wiggler(uint8 k);
void Spr086_Wiggler_02F0DB(uint8 k);
void Spr086_Wiggler_02F2D7(uint8 k);
void Spr086_Wiggler(uint8 k);
void Spr088_WingedCage(uint8 k);
void Spr088_WingedCage_Draw(uint8 k);
void Spr089_Layer3Smasher(uint8 k);
void Spr089_Layer3Smasher_02D49C(uint8 k);
void Spr08A_Bird(uint8 k);
void Spr08A_Bird_02F3C1(uint8 k);
void Spr08A_Bird_Draw(uint8 k);
void Spr08B_FireplaceSmoke_Draw(uint8 k);
void Spr08B_FireplaceSmoke(uint8 k);
void Spr08C_SideExitAndFireplace(uint8 k);
void Spr08C_SideExitAndFireplace_Draw(uint8 k);
void Spr08C_SideExitAndFireplace_SmokeSpawn(void);
void Spr08C_SideExitAndFireplace_SmokeSpawn_CheckEmptySlot(void);
void Spr08E_WarpHole(uint8 k);
void Spr08E_WarpHole_Return02EAF1(void);
void Spr08F_ScalePlatform(uint8 k);
void Spr08F_ScalePlatform_02E559(uint8 k, uint8 a);
void Spr08F_ScalePlatform_Draw(uint8 k);
void Spr08F_ScalePlatform_Sub(uint8 k);
void Spr090_GreenGasBubble(uint8 k);
void Spr090_GreenGasBubble_Draw(uint8 k);
void Spr046_DigginChuck(uint8 k);
void Spr091_CharginChuck_02C19A(uint8 k);
void Spr091_CharginChuck_02C22C(uint8 k);
void Spr091_CharginChuck_02C466(uint8 k);
void Spr091_CharginChuck_02C556(uint8 k);
void Spr091_CharginChuck_02C579(uint8 k);
void Spr091_CharginChuck_02C5BC(uint8 k);
void Spr091_CharginChuck_02C602(uint8 k);
void Spr091_CharginChuck_02C628(uint8 k);
void Spr091_CharginChuck_DrawBody(uint8 k, PointU8 pt);
void Spr091_CharginChuck_DrawDigginChuckExtraTiles(uint8 k, PointU8 pt);
void Spr091_CharginChuck_DrawExtraTiles(uint8 k, PointU8 pt);
PointU8 Spr091_CharginChuck_DrawHead(uint8 k, PointU8 pt);
void Spr091_CharginChuck_Draw(uint8 k);
void Spr091_CharginChuck_ProcessPlayerInteraction(uint8 k);
void Spr091_CharginChuck_Return02CBFC(void);
void Spr091_CharginChuck_State00_LookingSideToSide(uint8 k);
void Spr091_CharginChuck_State01_Charging(uint8 k);
void Spr091_CharginChuck_State02_PrepareToCharge(uint8 k);
void Spr091_CharginChuck_State03_Hurt(uint8 k);
void Spr091_CharginChuck_State04_Digging(uint8 k);
void Spr091_CharginChuck_State05_PrepareToJumpOrSplit(uint8 k);
void Spr091_CharginChuck_State06_Jumping(uint8 k);
void Spr091_CharginChuck_State07_LandFromJump(uint8 k);
void Spr091_CharginChuck_State08_Clappin(uint8 k);
void Spr091_CharginChuck_State09_Puntin(uint8 k);
void Spr091_CharginChuck_State0A_Pitchin(uint8 k);
void Spr091_CharginChuck_State0B_WaitToWhistle(uint8 k);
void Spr091_CharginChuck_State0C_Whistlin(uint8 k);
void Spr099_VolcanoLotus(uint8 k);
void Spr099_VolcanoLotus_02E079(uint8 k);
void Spr099_VolcanoLotus_Draw(uint8 k);
void Spr09A_SumoBro(uint8 k);
void Spr09A_SumoBro_02DCF9(uint8 k, uint8 a);
void Spr09A_SumoBro_02DD3F(uint8 k, uint8 a);
void Spr09A_SumoBro_Draw(uint8 k);
void Spr09A_SumoBro_GenSumoLightning(uint8 k);
void Spr09B_HammerBro(uint8 k);
void Spr09B_HammerBro_Init(uint8 k);
void Spr09B_HammerBro_Draw(uint8 k);
void Spr09C_HammerBroPlatform(uint8 k);
void Spr09C_HammerBroPlatform_Draw(uint8 k);
void Spr09D_BubbleWithSprite(uint8 k);
void Spr09D_BubbleWithSprite_Draw(uint8 k);
void Spr09E_BallNChain_Sub(uint8 k);
void Spr09E_BallNChain(uint8 k);
void Spr09F_BanzaiBill_Draw(uint8 k);
void Spr09F_BanzaiBill_Sub(uint8 k);
PointU8 Spr0A3_GreyChainedPlatform_02D813(uint8 k);
PointU8 Spr0A3_GreyChainedPlatform_02D848(uint8 k);
void Spr0DE_Load5Eeries(uint8 k, PointU16 pt, uint8 r2, const uint8 *edata);
void Spr0E0_Load3Platforms(PointU16 pt, uint8 r2, const uint8 *edata);
void Spr0E1_LoadBooCeiling(uint8 k, uint8 a, PointU16 pt, uint8 r2, const uint8 *edata);
void SprXXX_Dolphins(uint8 k);
void SprXXX_Dolphins_Draw(uint8 k);
void SprXXX_JumpingPiranhaPlant_02E17F(uint8 k);
void SprXXX_JumpingPiranhaPlant_02E1C0(uint8 k, uint8 a);
void Spr04F_JumpingPiranhaPlant(uint8 k);
void SprXXX_LoadShooter(uint8 k, uint8 a, PointU16 pt, const uint8 *edata);
void SprXXX_SuperKoopas_02EB3D(uint8 k, uint8 j);
void SprXXX_SuperKoopas_02EBB5(uint8 k, uint8 r0);
void SprXXX_SuperKoopas_02EBCA(uint8 k);
void SprXXX_SuperKoopas_02EBF8(uint8 k);
void SprXXX_SuperKoopas_Draw(uint8 k);
void SprXXX_SuperKoopas_GroundedSuperKoopaState00_Running(uint8 k);
void SprXXX_SuperKoopas_GroundedSuperKoopaState01_Jumping(uint8 k);
void SprXXX_SuperKoopas_GroundedSuperKoopaState02_Flying(uint8 k);
void SprXXX_SuperKoopas(uint8 k);
void Spr0A5_Sparky(uint8 k);
void SprXXX_WallFollowers_SparkyDraw(uint8 k);
void SprXXX_WallFollowers_UrchinDraw(uint8 k);
void SprXXX_WallSpringboard_Draw(uint8 k);
void SprXXX_WallSpringboard_HandlePlayerCollision(uint8 k, uint8 j, uint8 r2);
void SprXXX_WallSpringboard_Return02CDFE(uint8 k);
void SprXXX_WallSpringboard_State01_PlayerIsOnTop(uint8 k);
void SprXXX_WallSpringboard_State02_Rebound(uint8 k);
void SprXXX_WallSpringboard(uint8 k);
void SubOffscreen_Bank02_02D027(uint8 k, uint8 r3);
void SubOffscreen_Bank02_Entry1(uint8 k);
void SubOffscreen_Bank02_Entry2(uint8 k);
void SubOffscreen_Bank02_Entry3(uint8 k);
void SubOffscreen_Bank02_Entry4(uint8 k);
void SubOffscreen_Bank02_EraseSprite(uint8 k);
void UnusedGenTileFromSpr(uint8 k, uint8 a);
void UpdateBounceSpritePosition_X(uint8 k);
void UpdateBounceSpritePosition_Y(uint8 k);
void UpdateClusterSpritePosition_X(uint8 k);
void UpdateClusterSpritePosition_Y(uint8 k);
void UpdateExtendedSpritePosition_X(uint8 k);
void UpdateExtendedSpritePosition_Y(uint8 k);
void UpdateMinorExtendedSpritePosition_X(uint8 k);
void UpdateMinorExtendedSpritePosition_Y(uint8 k);
void YoshiStompRoutine(void);
void sub_284A6(uint8 k, uint8 a, uint8 r0, uint8 r2);
void sub_2D091(uint8 k);
void sub_2DFD0(uint8 k, uint8 a);
void sub_2E980(uint8 k, uint8 a);

// Bank 3
uint8 InitializeMode7TilemapsAndPalettes_03DE39(uint8 k, uint8 j, const uint8 *p0);
uint8 InitializeMode7TilemapsAndPalettes_03DE3C(uint8 k, uint8 j, const uint8 *p0);
uint8 Spr07C_PrincessPeach_03ADCC(uint8 k);
uint8 Spr0A0_ActivateBowserBattle_ReturnsTwice_03A5AD(uint8 k);
uint8 Spr0A0_ActivateBowserBattle_ReturnsTwice_03A661(uint8 k);
uint8 StandardSpriteToSpriteCollisionChecks_CheckContact(CollInfo *ci);
void DespawnNonBossSprites(void);
void FadingBooPaletteAnimation(void);
void GameMode12_PrepareLevel_03D991(const uint8 *p5, uint16 r0w);
void GameMode12_PrepareLevel_UploadTiltingPlatformTilemap(void);
void GameMode14_InLevel_03C0C6(void);
void GameMode14_InLevel_03C11E(void);
void HandleNormalSpriteLevelColl_03C1CA(uint8 k);
void InitializeMode7TilemapsAndPalettes_BufferReznorWallTilemap(void);
const uint8 *InitializeMode7TilemapsAndPalettes_BufferTilemap(uint16 **dstp, const uint8 *p0);
void InitializeMode7TilemapsAndPalettes(uint8 k);
void NormalSpriteBooDraw(uint8 k);
void SpawnFootball(uint8 k);
void Spr01B_Football(uint8 k);
void Spr029_KoopaKid_WendyLemmy(uint8 k);
void Spr029_KoopaKid_WendyLemmy_03CCE2(uint8 k);
void Spr029_KoopaKid_WendyLemmy_03CCE8(uint8 k, uint8 j);
void Spr029_KoopaKid_WendyLemmy_03CDCF(uint8 k);
void Spr029_KoopaKid_WendyLemmy_CheckMarioStomp(uint8 k);
void Spr029_KoopaKid_WendyLemmy_Draw(uint8 k);
void Spr029_KoopaKid_WendyLemmy_State00_InPipe(uint8 k);
void Spr029_KoopaKid_WendyLemmy_State01_Rising(uint8 k);
void Spr029_KoopaKid_WendyLemmy_State02_OutOfPipe(uint8 k);
void Spr029_KoopaKid_WendyLemmy_State03_Descending(uint8 k);
void Spr029_KoopaKid_WendyLemmy_State04_Hurt(uint8 k);
void Spr029_KoopaKid_WendyLemmy_State05_Falling(uint8 k);
void Spr029_KoopaKid_WendyLemmy_State06_SinkingInLava(uint8 k);
void Spr029_KoopaKid_WendyLemmy_Sub(uint8 k);
void Spr030_ThrowingDryBones_03C3DA(uint8 k);
void Spr030_ThrowingDryBones_DryBonesAndBonyBeetleDraw(uint8 k);
void Spr030_ThrowingDryBones_SpawnDryBonesBone(uint8 k);
void Spr051_Ninji(uint8 k);
void Spr054_ClimbingNetDoor_UpdateClimbingNetDoorTiles(uint8 k, uint8 a);
void Spr06F_DinoTorch(uint8 k);
void Spr06F_DinoTorch_DinoFlameClipping(uint8 k, CollInfo *ci);
void Spr06F_DinoTorch_DinoSetGfxFrame(uint8 k);
void Spr06F_DinoTorch_Draw(uint8 k);
void Spr06F_DinoTorch_Return039F37(void);
void Spr06F_DinoTorch2(uint8 k);
void Spr07A_Fireworks(uint8 k);
void Spr07A_Fireworks_03C8B1(uint8 k);
void Spr07A_Fireworks_03C96D(uint8 k);
void Spr07A_Fireworks_03C9E9(uint8 k);
void Spr07A_Fireworks_Explode(uint8 k);
void Spr07A_Fireworks_FadeAway(uint8 k);
void Spr07A_Fireworks_InitialFire(uint8 k);
void Spr07A_Fireworks_ShootUp(uint8 k);
void Spr07C_PrincessPeach(uint8 k);
void Spr07C_PrincessPeach_03AED0(uint8 k);
void Spr07C_PrincessPeach_DisplayMessage(uint8 k);
void Spr07C_PrincessPeach_DisplayPeachRescueMessage(void);
void Spr07C_PrincessPeach_FadeText(uint8 k);
void Spr07C_PrincessPeach_Fireworks(uint8 k);
void Spr07C_PrincessPeach_FloatingDown(uint8 k);
void Spr07C_PrincessPeach_GFXRt_DrawHELP(uint8 k, uint8 j, uint8 r2, uint8 r3);
void Spr07C_PrincessPeach_GFXRt_DrawPeach(uint8 k, uint8 j, PointU8 pt, uint8 r3);
void Spr07C_PrincessPeach_KissBro(uint8 k);
void Spr07C_PrincessPeach_StandByBro(uint8 k);
void Spr07C_PrincessPeach_WaitAfterFall(uint8 k);
void Spr07C_PrincessPeach_WalkTowardsBro(uint8 k);
void Spr0A0_ActivateBowserBattle_Init(uint8 k);
void HandleExtraSprites(uint8 k);
void Spr0A0_ActivateBowserBattle_03A4D2(uint8 k);
void Spr0A0_ActivateBowserBattle_03A4ED(uint8 k);
void Spr0A0_ActivateBowserBattle_03A4FD(uint8 k);
void Spr0A0_ActivateBowserBattle_03A61D(uint8 k);
void Spr0A0_ActivateBowserBattle_03A6AC(uint8 k);
void Spr0A0_ActivateBowserBattle_03A8D6(uint8 k);
void Spr0A0_ActivateBowserBattle_03AC63(uint8 k);
void Spr0A0_ActivateBowserBattle_03AF59(uint8 k);
void Spr0A0_ActivateBowserBattle_03B019(uint8 k);
void Spr0A0_ActivateBowserBattle_03B020(uint8 k, uint8 r2);
void Spr0A0_ActivateBowserBattle_03B078(uint8 k);
void Spr0A0_ActivateBowserBattle_03B0D2(uint8 k);
void Spr0A0_ActivateBowserBattle_03B0D6(uint8 k);
void Spr0A0_ActivateBowserBattle_03B0DC(uint8 k);
void Spr0A0_ActivateBowserBattle_03B0F3(uint8 k, uint8 j);
void Spr0A0_ActivateBowserBattle_DrawCastleRoof(void);
void Spr0A0_ActivateBowserBattle_DrawItemBox(void);
void Spr0A0_ActivateBowserBattle_Draw(void);
void Spr0A0_ActivateBowserBattle_SmokeDraw(uint8 k);
void Spr0A0_ActivateBowserBattle_State00_InitialDescent(uint8 k);
void Spr0A0_ActivateBowserBattle_State01_SwoopOut(uint8 k);
void Spr0A0_ActivateBowserBattle_State02_SwoopIn(uint8 k);
void Spr0A0_ActivateBowserBattle_State03_DropFireballs(uint8 k);
void Spr0A0_ActivateBowserBattle_State04_RiseUpToDie(uint8 k);
void Spr0A0_ActivateBowserBattle_State05_ClownCarMalfunction(uint8 k);
void Spr0A0_ActivateBowserBattle_State06_DropPeachAndFlyOff(uint8 k);
void Spr0A0_ActivateBowserBattle_State07_Phase1(uint8 k);
void Spr0A0_ActivateBowserBattle_State08_Phase2(uint8 k);
void Spr0A0_ActivateBowserBattle_State09_Phase3(uint8 k);
void Spr0A0_ActivateBowserBattle_Sub(uint8 k);
void Spr0A0_ActivateBowserBattle_UpdatePaletteAndLightningAnimation(void);
void Spr0A1_BowserBowlingBall(uint8 k);
void Spr0A1_BowserBowlingBall_Draw(uint8 k);
void Spr0A1_BowserBowlingBall_MakeBallBounce(uint8 k);
void Spr0A2_MechaKoopa(uint8 k);
void Spr0A2_MechaKoopa_Draw(uint8 k);
void Spr0A2_MechaKoopa_KeyDraw(uint8 k);
void Spr0A2_MechaKoopa_MechakoopaDraw(uint8 k);
void Spr0A8_Blargg(uint8 k);
void Spr0A8_Blargg_039FC0(uint8 k);
void Spr0A8_Blargg_03A045(uint8 k);
void Spr0A8_Blargg_Draw(uint8 k);
void Spr0A9_Reznor_Init(uint8 k);
void Spr0A9_Reznor(uint8 k);
void Spr0A9_Reznor_BreakReznorBridge(void);
void Spr0A9_Reznor_03D759(void);
void Spr0A9_Reznor_03D766(void);
void Spr0A9_Reznor_03D76C(void);
void Spr0A9_Reznor_03D77F(void);
void Spr0A9_Reznor_Draw(uint8 k);
void Spr0A9_Reznor_PlatformDraw(uint8 k);
void Spr0A9_Reznor_ReznorFireRt(uint8 k);
void Spr0AA_Fishbone(uint8 k);
void Spr0AA_Fishbone_Draw(uint8 k);
void Spr0AB_Rex(uint8 k);
void Spr0AB_Rex_Draw(uint8 k);
void Spr0AB_Rex_RexPoints(uint8 k);
void Spr0AC_DownFirstWoodenSpike(uint8 k);
void Spr0AC_DownFirstWoodenSpike_039475(uint8 k, uint8 a);
void Spr0AC_DownFirstWoodenSpike_039488(uint8 k);
void Spr0AC_DownFirstWoodenSpike_Draw(uint8 k);
void Spr0AE_FishinBoo(uint8 k);
void Spr0AE_FishinBoo_0390F3(uint8 k);
void Spr0AE_FishinBoo_Draw(uint8 k);
void Spr0B1_CreateEatBlock(uint8 k);
void Spr0B1_CreateEatBlock_GenTileFromSpr1(uint8 k, uint8 a);
void Spr0B2_FallingSpike(uint8 k);
void Spr0B3_BowserStatueFire(uint8 k);
void Spr0B3_BowserStatueFire_Draw(uint8 k);
void Spr0B7_CarrotTopLiftUpperRight_038CE4(uint8 k, CollInfo *ci);
void Spr0B7_CarrotTopLiftUpperRight_Draw(uint8 k);
void Spr0B8_CarrotTopLiftUpperLeft(uint8 k);
void Spr0B9_MessageBox(uint8 k);
void Spr0BA_TimedPlatform(uint8 k);
void Spr0BA_TimedPlatform_Draw(uint8 k);
void Spr0BB_MovingCastleStone(uint8 k);
void Spr0BB_MovingCastleStone_Draw(uint8 k);
void Spr0BC_BowserStatue(uint8 k);
void Spr0BC_BowserStatue_038ACB(uint8 k);
void Spr0BC_BowserStatue_Draw(uint8 k);
void Spr0BD_SlidingNakedBlueKoopa(uint8 k);
void Spr0BD_SlidingNakedBlueKoopa_0389FF(uint8 k);
void Spr0BE_Swooper(uint8 k);
void Spr0BE_Swooper_038915(uint8 k);
void Spr0BE_Swooper_FlyStraight(uint8 k);
void Spr0BE_Swooper_Swooping(uint8 k);
void Spr0BE_Swooper_Waiting(uint8 k);
void Spr0BF_MegaMole(uint8 k);
void Spr0BF_MegaMole_Draw(uint8 k);
void Spr0C0_SinkingLavaPlatform(uint8 k);
void Spr0C0_SinkingLavaPlatform_Draw(uint8 k);
void Spr0C1_WingedPlatform(uint8 k);
void Spr0C1_WingedPlatform_Draw(uint8 k);
void Spr0C2_Blurp(uint8 k);
void Spr0C3_PorcuPuffer(uint8 k);
void Spr0C3_PorcuPuffer_Draw(uint8 k);
void Spr0C4_GreyFallingPlatform(uint8 k);
void Spr0C4_GreyFallingPlatform_Draw(uint8 k);
void Spr0C5_BigBooBoss(uint8 k);
void Spr0C5_BigBooBoss_03811F(uint8 k);
void Spr0C5_BigBooBoss_0381E4(uint8 k);
void Spr0C5_BigBooBoss_Dying(uint8 k);
void Spr0C5_BigBooBoss_FadingIn(uint8 k);
void Spr0C5_BigBooBoss_FadingOut(uint8 k);
void Spr0C5_BigBooBoss_FloatingAroundWhileInvisible(uint8 k);
void Spr0C5_BigBooBoss_FloatingAroundWhileVisible(uint8 k);
void Spr0C5_BigBooBoss_Hurt(uint8 k);
void Spr0C5_BigBooBoss_StoppedBeforeFadeIn(uint8 k);
void Spr0C6_Spotlight(uint8 k);
void Spr0C6_Spotlight_Draw(uint8 k);
void Spr0C7_InvisibleMushroom(uint8 k);
void Spr0C7_InvisibleMushroom_PopupMushroom(uint8 k);
void Spr0C8_LightSwitch(uint8 k);
void SprXXX_LineGuided_ChainsawDraw(uint8 k);
void SprXXX_LineGuided_ChainsawDraw(uint8 k);
void SprXXX_ReflectingEnemy_038FA4(uint8 k);
void SprXXX_ReflectingEnemy_ReflectingBooBuddiesEntry(uint8 k);
void SprXXX_ReflectingEnemy_ReflectingPodobooEntry(uint8 k);
void SprXXX_ReflectingEnemy_ReflectingPodobooDraw(uint8 k);
void SprXXX_ReflectingEnemy_SpawnTrailingBoo(uint8 k);
void StandardSpriteToSpriteCollisionChecks_GetMarioClipping(CollInfo *ci);
void StandardSpriteToSpriteCollisionChecks_GetSpriteClippingA(uint8 k, CollInfo *ci);
void StandardSpriteToSpriteCollisionChecks_GetSpriteClippingB(uint8 k, CollInfo *ci);
void SubOffscreen_Bank03_03B85F(uint8 k, uint8 r3);
void SubOffscreen_Bank03_Entry1(uint8 k);
void SubOffscreen_Bank03_Entry4(uint8 k);
void TriggerHidden1up(void);
void UpdateMode7SpriteAnimations_03DFAE(uint8 j, uint16 a);
void UpdateMode7SpriteAnimations(uint8 k);
void sub_3CDDA(uint8 k, uint8 a);

// Bank 4
uint16 CalculateOverworldPlayerPosition(uint8 k, uint16 r0w, uint16 r2w);
uint16 LoadOverworldLayer1AndEvents_InitializedOverworldLayer1Tilemap(uint16 k, uint8 a);
uint8 CheckPlayerToOverworldSpriteCollision(uint8 k);
uint8 CheckIfXIsAllowedOnYSubmap_Lightning(uint8 a);
uint8 CheckIfXIsAllowedOnYSubmap_Sprites(uint8 k);
uint16 DrawFlyingSwitchBlocks_04F39C(uint8 k, uint8 j);
uint8 DrawOverworldPlayer_DrawCurrentPlayer(uint8 k, uint8 j, PointU8 pt, uint8 tmp8c, uint16 r4w, uint8 r6);
uint8 DrawOverworldSpriteShadow_04FE45(uint8 j, uint8 a, PointU16 pt, uint8 r4, uint8 r5);
bool HandleOverworldStarPipeWarp_GetIndex(void);
uint8 OWSpr03_CheepCheep_GenericOverworldSpriteGFXRt_Draw8x8(uint8 j, uint16 a, PointU16 pt);
uint8 OWSpr04_PiranhaPlant_GenericOverworldSpriteGFXRt_Entry2(uint8 j, uint16 a, uint8 cr, PointU16 pt);
uint8 SetOverworldSpriteFrameIndex(uint8 k);
void BufferEventTileToLayer2Tilemap_Buffer2x2Tile(uint16 k, uint16 j, uint16 r4, const uint8 *r6, const uint8 *r9);
void BufferEventTileToLayer2Tilemap_Buffer6x6Tile(uint16 k, uint16 j, uint16 r4, const uint8 *r6, const uint8 *r9);
void BufferEventTileToLayer2Tilemap_Entry2(uint16 k, uint16 j, uint16 r4);
void BufferEventTileToLayer2Tilemap(void);
uint16 BufferEventTileToStripeImageTable_Buffer2x2Tile(uint16 r0w, uint16 r2w, uint16 r10, const uint8 *r12);
uint16 BufferEventTileToStripeImageTable_Buffer6x6Tile(uint16 r0w, uint16 r2w, uint16 r10, const uint8 *r12);
void BufferOverworldLayer2Tilemap(uint16 k, uint16 j, uint16 r14w, const uint8 *p0);
typedef struct OwHvPos {
  uint16 r0;
  uint16 r2;
  uint16 r6;
  uint16 r8;
} OwHvPos;
OwHvPos CheckPlayerToOverworldSpriteColl_SubOverworldHorizAndVertPos(uint8 k);
uint16 CheckIfDestroyTileEventIsActive(uint8 a);
void DisplayOwPrompt(uint8 a);
void DrawFlyingSwitchBlocks(void);
void DrawOverworldPlayer_DrawHalo(uint16 k, uint16 r4, PointU8 pt);
void DrawOverworldPlayer(void);
void DrawOverworldSpriteShadow(uint8 k, uint8 cr);
void GameMode0C_LoadOverworld_048D91(void);
void GameMode0C_LoadOverworld_048E55(void);
void GameMode0E_ShowOverworld_Bank04(void);
void GameMode0E_ShowOverworld_UpdateMainMapFreeScrollingPosition(uint8 k, uint8 a);
PointU16 GetOverworldSpriteOnScreenPosition(uint8 k);
uint16 GetOverworldSpriteOnScreenPosition_Y(uint8 k, uint8 j);
PointU8 GetXAndYDispOfCurrentEventTileSprite(void);
void HandleCurrentOverworldProcess(void);
void HandleOverworldPathExits(void);
void HandleOverworldPathExits_SetLayerPositions(void);
void HandleOverworldStarPipeWarp_SetPlayerDestination(void);
void InitializeOverworldTilemaps(void);
void LoadOverworldLayer1AndEvents_04D7F2(void);
void LoadOverworldLayer1AndEvents_04DA49(uint8 r15);
void LoadOverworldLayer1AndEvents(void);
void LoadOverworldLayer2AndEventsTilemaps_04DD40(void);
void LoadOverworldLayer2AndEventsTilemaps_04DD57(uint16 k, uint16 j, const uint8 *p2);
void LoadOverworldLayer2AndEventsTilemaps_04E453(uint8 r15);
void LoadOverworldLayer2AndEventsTilemaps(void);
void LoadOverworldLayer2AndEventsTilemaps_Sub(void);
void LoadOverworldSprites(void);
void OWSpr01_Lakitu_04F993(uint8 k, uint8 cr);
void OWSpr01_Lakitu_CalculateOverworldLakitusSpeed(uint8 k);
void OWSpr01_Lakitu(uint8 k);
void OWSpr02_BlueBird(uint8 k);
void OWSpr03_CheepCheep_04FA7D(uint8 k);
void OWSpr03_CheepCheep_04FA83(uint8 k);
void OWSpr03_CheepCheep(uint8 k);
uint8 OWSpr04_PiranhaPlant_GenericOverworldSpriteDraw(uint8 k, uint16 a, PointU16 pt);
void OWSpr04_PiranhaPlant(uint8 k);
void OWSpr05_Cloud_04FB77(uint8 a, PointU16 pt);
void OWSpr05_Cloud_04FB7A(uint16 a, PointU16 pt);
void OWSpr05_Cloud_04FB7B(uint16 a, uint8 cr, PointU16 pt);
void OWSpr05_Cloud(uint8 k);
void OWSpr06_KoopaKid(uint8 k);
void OWSpr07_Smoke(uint8 k);
void OWSpr08_BowserSign(uint8 k);
void OWSpr09_Bowser_04FD55(uint8 k, uint8 j);
void OWSpr09_Bowser(uint8 k);
void OWSpr0A_Boo_04FDD2(uint8 k, uint8 a, uint8 r0);
void OWSpr0A_Boo(uint8 k);
void OwEventProcess00_CheckIfEventShouldRun(void);
void OwEventProcess01_DestroyTileAnimation_04ED83(void);
void OwEventProcess01_DestroyTileAnimation_04EDE6(uint16 k, uint16 r0w, const uint8 *p);
void OwEventProcess01_DestroyTileAnimation_04EEAA(void);
void OwEventProcess02_SetEventTileIndexes(void);
void OwEventProcess03_GetLayer2Tile_04EA62(void);
void OwEventProcess03_GetLayer2Tile_04EA8B(void);
void OwEventProcess03_GetLayer2Tile(void);
void OwEventProcess04_FadeInLayer2Tile_04EE30(void);
void OwEventProcess04_FadeInLayer2Tile(void);
void OwEventProcess05_GetLayer1Tile(void);
void OwEventProcess06_FadeInLayer1Tile(void);
void OwEventProcess07_SilentEventsAndEndOfEvent_Entry2(uint8 a, bool from_where);
void OwEventProcess07_SilentEventsAndEndOfEvent(void);
void OverworldLightningAndRandomCloudSpawning(void);
void OverworldLightningAndRandomCloudSpawning_Return04F828(uint8 k);
void OwProcess00_OverworldEntryInitialization(void);
void OwProcess01_ActivateEvents(void);
void OwProcess02_HandleLevelBeaten(void);
void OwProcess03_StandingStill(void);
void OwProcess04_PlayerIsMoving_049831(void);
void OwProcess04_PlayerIsMoving_04983F(void);
void OwProcess04_PlayerIsMoving(void);
void OwProcess05_CheckPlayerSwitch(void);
void OwProcess07_SwitchingPlayers(void);
void OwProcess08_PlayerSwitchFadeIn(void);
void OwProcess09_FinishedSwitchingPlayers(void);
void OwProcess0A_SwitchBetweenSubmaps(void);
void OwProcess0B_StarWarpAnimation(void);
void OwProcess0C_IntroMarch(void);
void OwPrompt01_InitializeOwPrompt_04F407(void);
void OwPrompt01_InitializeOwPrompt(void);
void OwPrompt02_ExpandPromptWindow(void);
void OwPrompt03_OverworldLifeExchanger_04F60E(uint8 k, uint8 j, uint8 a);
void OwPrompt03_OverworldLifeExchanger(void);
void OwPrompt07_DisplayingSavePrompt(void);
void OwTileAnimations_0480B9(uint16 k, const uint8 *p0);
void OwTileAnimations_048172(uint8 k);
void OwTileAnimations(void);
void OwTileAnimations_ShiftWaterTiles(void);
void ProcessOverworldSprites(uint8 k);
void SubmapSwitchProcess01_UpdateLayer1(void);
void SubmapSwitchProcess05_UpdatePalette(void);
void SubmapSwitchProcess06_EndWindowHDMA(void);
void SubmapSwitchProcess07_EndSubmapSwitch(void);
uint16 UnlockOverworldPathBasedOnExit(void);
uint16 UpdateLevelName_049D7F(uint16 j, uint16 k, uint16 r2w);
void UpdateLevelName(uint16 r0w);
void UpdateOverworldSpritePosition(uint8 k);
void UpdateOverworldSpritePosition_X(uint8 k);
void UpdateSaveBuffer(void);
void sub_485A4(void);
void sub_485A7(void);

// Bank 5
uint16 InitializeLevelData_Hi(uint16 k, uint8 a);
uint16 InitializeLevelData_Lo(uint16 k, uint8 a);
uint8 UnusedOverworldEventPassedCheck(uint8 j);
void AdjustTimeBonusDisplay(uint8 k, uint8 j, uint16 R0_W_, uint16 r2w);
void BeginLoadingLevelData(void);
void BufferBGTilemap(uint8 *r13);
void BufferScrollingTiles_Layer1_Main(void);
void BufferScrollingTiles_Layer1_Init(void);
void BufferScrollingTiles_Layer1(void);
void BufferScrollingTiles_Layer1_NoScroll(void);
void BufferScrollingTiles_Layer1_VerticalLevel(void);
void BufferScrollingTiles_Layer2_Main(void);
void BufferScrollingTiles_Layer2_Background(void);
void BufferScrollingTiles_Layer2_Init(void);
void BufferScrollingTiles_Layer2(void);
void BufferScrollingTiles_Layer2_NoScroll(void);
void BufferScrollingTiles_Layer2_VerticalLevel(void);
void CalculateRowOrColumnOfTilemapToUpdate(void);
uint16 CalculateTimeBonusDigits(void);
void CheckIfLevelTilemapsNeedScrollUpdate(void);
void DisplayCourseClearTextBonusStars(void);
void DisplayMessage_DrawSwitchBlocks(uint8 k);
void DisplayMessage_ExitToOverworldNoEvent(void);
void DisplayMessage(void);
void DisplayMessage_RemoveSwitchBlocks(void);
void GameMode12_PrepareLevel_InitializeLayer3RAM(void);
void GiveCoins_MultipleCoins(uint8 a);
void GiveCoins_MultipleCoins_NoCoinSound(uint8 a);
void GiveCoins_OneCoin(void);
void GiveTimeBonusAndBonusStars(void);
void GiveTimeBonusAndBonusStars_Return(void);
void HandleScrollSpriteAndLayer3Scrolling(void);
void InitializeLevelLayer1And2Tilemaps(void);
void InitializeMap16Pointers(void);
void InitializeScrollSprites_05BCE9(void);
void InitializeScrollSprites_05BD0E(void);
void InitializeScrollSprites(void);
void InitializeScrollSprites_Return05BD35(void);
void Layer1SpecialScrolling00_VariableScroll(void);
void Layer1SpecialScrolling04_Unused(void);
void Layer1SpecialScrolling05_Unused(void);
void Layer1SpecialScrolling08_Layer2ScrollSOrL(void);
void Layer1SpecialScrolling0A_Unused(void);
void Layer1SpecialScrolling0B_Layer2OnOffControlled(void);
void Layer1SpecialScrolling0C_RegularAutoScroll(void);
void Layer2SpecialScrolling01_VariableScroll(void);
void Layer2SpecialScrolling02_Layer2Smash_05C95B(uint8 k, uint8 j);
void Layer2SpecialScrolling02_Layer2Smash(void);
void Layer2SpecialScrolling03_Layer2Scroll(void);
void Layer2SpecialScrolling04_Unused_05C328(uint8 k);
void Layer2SpecialScrolling06_Unused(void);
void Layer2SpecialScrolling0D_FastBGScroll_Flagged(void);
void Layer2SpecialScrolling0D_FastBGScroll_NonFlagged(void);
void Layer2SpecialScrolling0E_Layer2ScrollWhenTouched(void);
void HandleLevelTileAnimations(void);
void LoadLevelDataObject_0585D8(void);
void ProcessExtendedObjects(void);
void ProcessStandardAndTilesetSpecificObjects(void);
void LoadLevelDataObject(void);
void LoadLevelHeader(void);
void LoadOverworldLifeCounter(void);
void LoadSublevel(void);
void MostlyUnusedScrollSpriteRoutine_05BDC9(uint8 k);
void MostlyUnusedScrollSpriteRoutine_05BDCF(uint8 k);
void MostlyUnusedScrollSpriteRoutine(void);
void ProcessLevelEndRoutines(void);
void ProcessLevelEndRoutines(void);
void ProcessScrollSprites_Layer1(void);
void ProcessScrollSprites_Layer2(void);
void ProcessScrollSprites_Return(void);
void ScrollLayer3(void);
void ScrollSecondInteractiveLayer(void);
void ScrollSecondInteractiveLayer(void);
void ShowCourseClearText(void);
void LoadLevel_05DBAC(void);
void LoadLevel_HandleChocolateIsland2Gimmick(void);
bool LoadLevel(void);
void Spr0E7_SpecialAutoScroll_Layer2(void);
void Spr0E7_SpecialAutoScroll(void);
void Spr0E9_Layer2Smash(void);
void Spr0EA_Layer2Scroll_05BF20(void);
void Spr0EA_Layer2Scroll(void);
void Spr0EB_UnusedSprite_05BDF0(void);
void Spr0EB_UnusedSprite(void);
void Spr0EC_UnusedSprite_05BFD2(uint16 a);
void Spr0EC_UnusedSprite_05BFD5(uint16 a);
void Spr0EC_UnusedSprite(void);
void Spr0EC_UnusedSprite_Return05BFF5(void);
void Spr0ED_Layer2Falls(void);
void Spr0EF_Layer2ScrollSOrL_05BEC6(void);
void Spr0EF_Layer2ScrollSOrL(void);
void Spr0F1_UnusedSprite_05BE4D(void);
void Spr0F1_UnusedSprite(void);
void Spr0F2_Layer2OnOffControlled(void);
void Spr0F3_RegularAutoScroll(void);
void Spr0F4_FastBGScroll_05C022(void);
void Spr0F4_FastBGScroll(void);
void Spr0F5_Layer2ScrollWhenTouched(void);
void UnusedScrollSpriteRoutine(void);
void UpdateLayerPositionWithScrollSprite(uint8 k);
void sub_5B165(uint8 a);

// Bank 7
uint8 Spr07B_GoalTape_07F200(uint8 k, uint8 j, uint16 R2, uint16 r4);
void InitializeNormalSpriteRAMTables_ClearTables(uint8 k);
void InitializeNormalSpriteRAMTables(uint8 k);
void InitializeNormalSpriteRAMTables_PropertyTables(uint8 k);
void InitializeNormalSpriteRAMTables_YXPPCCCTAndPropertyTables(uint8 k);
void SpawnSpinJumpStars_07FC47(uint8 k);
void SpawnSpinJumpStars(uint8 k);
void Spr07B_GoalTape_BonusStarNumbersDraw(uint8 k);
void Spr07B_GoalTape_GiveBonusStars(uint8 k);

// Bank C
void BufferCreditsBackgrounds_0C944C(uint16 r13w, const uint8 *src);
void BufferCreditsBackgrounds_0C94C0(uint16 mask);
void BufferCreditsBackgrounds(void);
void CarryEggAwayFromCastle(void);
void CheckIfPlayerCanEndCastleDestructionCutscene(void);
void ClearCutsceneSpritesSubpixelPosition(void);
void CopyOfUpdateCutsceneSpritePosition_X(uint8 k);
void CopyOfUpdateCutsceneSpritePosition_Y(uint8 k);
void CreditsFadeOut_0CABB2(void);
void CreditsFadeOut(void);
void CreditsFadeOut(void);
void DelayTNTExplosionUntilPlayerComesBy(void);
void DisplayCastleDestructionText(void);
void DrawCameraFacingEndingYoshis_BlueYoshi(uint8 k, uint8 j, uint8 r14, uint8 r0, uint8 r2);
void DrawCastleDestructionCastleDoor_Entry3(uint8, uint8 r0, uint8 r1, uint8 r2);
void DrawCastleDestructionCastleDoor(void);
void DrawCreditsPeachRedAndYellowYoshi_Peach(uint8 k, uint8 j, uint16 r0w, uint8 r2);
void DrawCutsceneContactEffect(void);
void DrawEndingBabyYoshis(uint8 r2);
uint8 DrawEndingThankYou_0CA183(uint8 k, uint8 j, uint16 r8, uint16 r0w, uint16 r2);
void DrawEndingThankYou_Entry2(uint8 k, uint8 j, uint16 r0w, uint16 r4, uint16 r8);
void DrawEndingThankYou(void);
void DrawLeaningEndingYoshis(uint8 k, uint8 j, uint8 r0, uint8 r2);
void DrawPlayerCough_MortonCutscene(void);
void DrawPlayerCough_RoyCutscene(void);
void DrawQuestionMark(void);
void DrawTNTFuseBox(void);
void DrawThankYouSpeechBubble(void);
void DrawWhiteFlag(uint8 k, uint8 r0);
void DrawWoodHammer(void);
void DrawingTheEndMarioLuigiAndPeach(void);
void EveryoneCheeringDuringEnding(void);
void GameMode19_Cutscene_0CC97E(void);
void GameMode19_Cutscene_IggyCutscene(void);
void GameMode19_Cutscene_LarryCutscene(void);
void GameMode19_Cutscene_LemmyCutscene(void);
void GameMode19_Cutscene_LudwigCutscene(void);
void GameMode19_Cutscene_MortonCutscene(void);
void GameMode19_Cutscene_ProcessCutscene(void);
void GameMode19_Cutscene_RoyCutscene(void);
void GameMode19_Cutscene_WendyCutscene(void);
void GameMode1B_EndingCinema_Bank0C(void);
void GameMode1B_EndingCinema_BufferNextRowOfCredits(void);
uint16 GameMode1B_EndingCinema_0C9FCB(uint8 k);
void GameMode1B_EndingCinema_Sub(void);
void GameMode1D_LoadYoshisHouse_Bank0C(void);
void GameMode1D_LoadYoshisHouse_0CA1D4(void);
void GameMode1D_LoadYoshisHouse_DrawEndingYoshisHouseDecorations(void);
void GameMode1D_LoadYoshisHouse_InitializeYoshisHouseSceneRAM(void);
void GameMode21_DelayEnemyRollcall_Bank03(void);
void GameMode25_ShowEnemyRollcallScreen_Bank0C(void);
void GameMode25_ShowEnemyRollcallScreen_Sub(void);
void GetLayer1And2PointersForEnemyRollcall(void);
void HandleCastleCrumblingDown_DrawCastleRubble(void);
void HandleCastleCrumblingDown(void);
void HandleCastleLiftoff_0CCE2A(void);
void HandleCastleLiftoff_DrawCastleDust(void);
void HandleCastleLiftoff_DrawCastleRocketFlame(void);
void HandleCastleLiftoff(void);
void HandleDudTNTExplosion_0CCF90(void);
void HandleDudTNTExplosion_DrawDudTNTExplosion(uint8 k);
void HandleDudTNTExplosion(void);
void HandleFarawayCastleRocket_DrawSprite(void);
void HandleFarawayCastleRocket(void);
void HandlePlayerPoseAndAnimationTimersDuringEnding_0CA764(void);
void HandlePlayerPoseAndAnimationTimersDuringEnding(void);
void HandleTNTExplosion(void);
void HandleTNTExplosion_TNTExplosionDraw(void);
void HandleTNTFuse(void);
void HandleTNTFuse_TNTFuseAndLineDraw(void);
void HatchYoshiEggsDuringEnding_0CA5DE(void);
void HatchYoshiEggsDuringEnding(void);
void InitializeCastleCrumblingDown(void);
void InitializeCastleDestructionTextTimers_DontIncrementCutsceneProcess(void);
void InitializeCastleDestructionTextTimers(void);
void InitializeCastleDust(void);
void InitializeCastleLiftoff(void);
void InitializeCreditsEggPositions(void);
void InitializeDudTNTExplosion(void);
void InitializeEnemyRollcallLayerPositions(void);
void InitializeFarawayCastleRocket(void);
void InitializeTNTExplosion(void);
void KickCastleAway(void);
void KickedCastleCreatesQuake(void);
void MakeCreditsEggsBounce(uint8 r14);
void PlayerDropkicksAndStompsCastle(void);
void ProcessCheeringYoshis(void);
void ProcessHammerDebris(void);
void ProcessMop_EraseColumn(void);
void ProcessMop(void);
void RaiseFlagUpFromRubble(void);
void ShakeCutsceneCastle(void);
void SlideInThankYouDuringEnding(void);
void SpawnEndingYoshiSpriteAndDrawPlayer_0CA7B4(void);
void SpawnEndingYoshiSpriteAndDrawPlayer(void);
void SpawnHammerDebris(void);
void UpdateCreditsBackground(void);
void UpdateCutsceneSpritePosition_X(uint8 k);
void UpdateCutsceneSpritePosition_Y(uint8 k);
void UprootCastleFromGround(void);
void WaitBeforeMakingHammeredCastleCrumble(void);
void WaitForCastleDestructionTextToFinishInRoyCutscene(void);
void WaitForPlayerVictoryPoseAfterCastleQuake(void);
void WaitForWendysCastleToBeFullyMopped(void);
void WalkingIntoYoshisHouseDuringEnding_0CA1F6(void);
void WalkingIntoYoshisHouseDuringEnding_0CA2FC(void);
void YoshisWatchInExcitementDuringEnding_0CA478(void);
void YoshisWatchInExcitementDuringEnding_0CA4B6(void);
void YoshisWatchInExcitementDuringEnding_0CA4E9(void);
void YoshisWatchInExcitementDuringEnding_0CA510(uint8 j);
void YoshisWatchInExcitementDuringEnding(void);
void sub_CA1ED(void);
void sub_CCBFC(uint8 k);

// Bank D
uint8 ExtObjXX_LargeBush_HandleOverlappingBigBushTiles(uint8 j, uint8 a);
uint8 FillInSlopeTileAir(uint8 j, uint8 a);
uint8 GoDownLeftAndUpdateLevelDataPointerInObjects(void);
uint8 GoDownRightAndUpdateLevelDataPointerInObjects(void);
uint8 GrassObjXX_DiagonalLedge_AddDiagonalBlackLinesToDirt(uint8 j, uint8 a);
uint8 HandleHorizontalSubScreenCrossingForCurrentObject_Entry2(uint8 j);
uint8 HandleHorizontalSubScreenCrossingForCurrentObject(uint8 j, uint8 a);
uint8 HandleVerticalSubScreenCrossingForCurrentObject_HorizontalLevel(void);
void HandleVerticalSubScreenCrossingForCurrentObject_HorizontalLevel_Entry2(uint8 cr);
uint8 HandleVerticalSubScreenCrossingForCurrentObject_VerticalLevel(void);
uint8 StdObj13_GroundEdgesAndVine_0DB114(uint8 k, uint8 j, uint8 a);
uint8 StdObj13_GroundEdgesAndVine_0DB198(uint8 k, uint8 j, uint8 a);
void CastleObj34_VerticalDoubleEndedPipe(uint8 k);
void CastleObj35_RockWallBackground(uint8 k);
void CastleObj36_LargeSpikedPillar(uint8 k);
void CastleObj38_VerticalLineGuide(uint8 k);
void CastleObj3B_GrassLedge(uint8 k);
void CastleObj3C_StoneBlock(uint8 k);
void CastleObj3D_Escalator_LeftSlope(void);
void CastleObj3D_Escalator(uint8 k);
void CastleObj3D_Escalator_RightSlope(void);
void CastleObj3E_HorizontalLineOfSpikes(uint8 k);
void CastleObj3F_VerticalLineOfSpikes(uint8 k);
void ExtObj00_ScreenExit(uint8 k);
void ExtObj01_ScreenJump(uint8 k);
void ExtObj18_3upMoon(uint8 k);
void ExtObj41_YoshiCoin(uint8 k);
void ExtObj42_TopLeftSlope(uint8 k);
void ExtObj46_MidwayBar(uint8 k);
void ExtObj47_Door(uint8 k);
void ExtObj49_GhostHouseExit(uint8 k);
void ExtObj4A_ClimbingNetDoor(uint8 k);
void ExtObj4B_ConveyorEndTile1(uint8 k);
void ExtObj55_HorizontalLineGuideEnd(uint8 k);
void ExtObj56_VerticalLineGuideEnd(uint8 k);
void ExtObj5B_BitOfBrickBackground1(uint8 k);
void ExtObj5F_LargeBackgroundArea(uint8 k);
void ExtObj60_CaveLavaInnerCorner(uint8 k);
void ExtObj61_GhostHouseClock(uint8 k);
void ExtObj64_TopRightCobweb_GhostHouseWindowEntry(uint8 k);
void ExtObj65_TopLeftCobweb(uint8 k);
void ExtObj66_GhostHouseTopRightToBottomLeftBeam2(uint8 k);
void ExtObj6B_CloudFringeBottomLeft(uint8 k);
void ExtObj70_BitOfCanvas1(uint8 k);
void ExtObj71_Canvas1(uint8 k);
void ExtObj75_CanvasTile1(uint8 k);
void ExtObj7C_BitOfCanvas1(uint8 k);
void ExtObj7F_TorpedoLauncher(uint8 k);
void ExtObj80_GhostHouseEntrance(uint8 k);
void ExtObj81_Seaweed(uint8 k);
void ExtObj84_CastleEntrance(uint8 k);
void ExtObj85_YoshisHouse(uint8 k);
void ExtObj86_GoalSign(uint8 k);
void ExtObj89_LeftTreeBranch(uint8 k);
void ExtObj8D_SwitchPalaceSwitch(uint8 k);
void ExtObj8E_YellowSwitchBlock_0DB58D(uint8 k);
void ExtObj8E_YellowSwitchBlock_GreenSwitchBlockEntry(uint8 k);
void ExtObj8E_YellowSwitchBlock(uint8 k);
void ExtObj8F_GhostHouseWindow(uint8 k);
void ExtObj90_LargeBossDoor(uint8 k);
void ExtObj91_VerticalLevelSteepLeftSlope(uint8 k);
void ExtObj93_VerticalLevelNormalLeftSlope(uint8 k);
void ExtObj95_VerticalLevelVerySteepLeftSlope(uint8 k);
void ExtObj97_SwitchPalaceRightAndBottomEdgeTile(uint8 k);
void ExtObjXX_Generic1TileObject_0DA57F(uint8 k, uint8 a);
void ExtObjXX_Generic1TileObject_GreenStarBlockEntry(uint8 k);
void ExtObjXX_LargeBush_BigBushEntry(uint8 k);
void ExtObjXX_LargeBush_SmallBushEntry(uint8 k);
void ExtObjXX_LineGuideQuarterLargeCircle(uint8 k);
void ExtObjXX_LineGuideQuarterSmallCircle(uint8 k);
void ExtObjXX_PurpleTriangle(uint8 k);
void GhostHouseObj2E_HorizontalLineOfSpikes(uint8 k);
void GhostHouseObj30_GrassLedge1(uint8 k);
void GhostHouseObj31_WoodCrate(uint8 k);
void GhostHouseObj32_GrassLedge2(uint8 k);
void GhostHouseObj33_Cloud(uint8 k);
void GhostHouseObj34_WoodLedgeOnColumn(uint8 k);
void GhostHouseObj35_BrickBackground_0DECCE(uint8 k);
void GhostHouseObj35_BrickBackground_LogBackgroundEntry(uint8 k);
void GhostHouseObj36_WoodenBlocks(uint8 k);
void GhostHouseObj37_HorizontalBackgroundLogAndRailing(uint8 k);
void GhostHouseObj38_WoodenLedge(uint8 k);
void GhostHouseObj38_WoodenLedge_WoodLedgeOnColumnEntry(uint8 k, uint8 j);
void GhostHouseObj39_VerticalBackgroundLog(uint8 k);
void GhostHouseObj3A_SolidBrickWallAndVerticalLineOfSpikes(uint8 k);
void GhostHouseObj3B_BonusGameLedge(uint8 k);
void GhostHouseObj3C_SwitchPalaceCeiling(uint8 k);
void GhostHouseObj3D_SwitchPalaceLedge(uint8 k);
void GhostHouseObj3E_SwitchPalaceRightFacingWall(uint8 k);
void GhostHouseObj3F_SwitchPalaceLeftFacingWall(uint8 k);
void GoBackOneScreenAndUpdateLevelDataPointerInObjects(void);
void GoForwardOneScreenAndUpdateLevelDataPointerInObjects(void);
void GrassObj30_IcyVerticalPipe(uint8 k);
void GrassObj32_BlueSwitchBlocks_0DB920(uint8 k);
void GrassObj32_BlueSwitchBlocks_RedSwitchBlockEntry(uint8 k);
void GrassObj33_ForestTreeTop(uint8 k);
void GrassObj34_ForestGroundEdges(uint8 k);
void GrassObj35_ForestGround(uint8 k);
void GrassObj36_LargeTreeTrunk_0DB9F6(uint8 k, uint8 j);
void GrassObj36_LargeTreeTrunk(uint8 k);
void GrassObj37_SmallTreeTrunk_0DB997(uint8 k, uint8 j, uint8 a);
void GrassObj37_SmallTreeTrunk(uint8 k);
void GrassObj39_RightFacingDiagonalPipe(uint8 k);
void GrassObj3C_ArchLedge(uint8 k);
void GrassObj3D_TopCloudFridge(uint8 k);
void GrassObj3E_SideCloudFridges(uint8 k);
void GrassObj3F_SmallBushes(uint8 k);
void GrassObjXX_DiagonalLedge_LeftFacingDiagonalLedgeEntry(uint8 k);
void GrassObjXX_DiagonalLedge_RightFacingDiagonalLedgeEntry(uint8 k);
void PreserveLevelDataPointerInObjects(void);
void ProcessCastleObjects(void);
void ProcessExtendedObjects(void);
void ProcessExtendedObjects_Sub(void);
void ProcessGhostHouseObjects(void);
void ProcessGrasslandObjects(void);
void ProcessRopeObjects(void);
void ProcessStandardAndTilesetSpecificObjects(void);
void ProcessStandardAndTilesetSpecificObjects(void);
void ProcessUndergroundObjects(void);
void RestoreLevelDataPointerInObjects(void);
void RopeObj2E_Unused(uint8 k);
void RopeObj32_LogBridge(uint8 k);
void RopeObj33_BlueSwitchBlocks(uint8 k);
void RopeObj35_ColumnWithPlantOnTop(uint8 k);
void RopeObj36_HorizontalConveyorRope(uint8 k);
void RopeObj38_HorizontalLineGuide(uint8 k);
void RopeObj3A_SlopedLineGuide(uint8 k);
void RopeObj3A_SlopedLineGuideLeftSlope(uint8 k);
void RopeObj3A_SlopedLineGuideRightSlope(uint8 k);
void RopeObj3A_SlopedLineGuide_ONOFFLeftSlope(uint8 k);
void RopeObj3A_SlopedLineGuide_ONOFFRightSlope(uint8 k);
void RopeObj3B_VerySteepSlopedLineGuide(uint8 k);
void RopeObj3B_VerySteepSlopedLineGuide_VerySteepLeftSlope(void);
void RopeObj3B_VerySteepSlopedLineGuide_VerySteepRightSlope(void);
void RopeObj3C_MushroomTop(uint8 k);
void RopeObj3D_MushroomColumn(uint8 k);
void RopeObj3E_HorizontalLog(uint8 k);
void RopeObj3F_VerticalLog(uint8 k);
void SetMap16HighByteForCurrentObject_Page00(uint8 j);
void SetMap16HighByteForCurrentObject_Page01(uint8 j);
void SetMap16LowByte(uint16 j, uint8 a);
void StdObj05_Coins(uint8 k);
void StdObj0F_VerticalPipes(uint8 k);
void StdObj10_HorizontalPipes(uint8 k);
void StdObj11_BulletShooter(uint8 k);
void StdObj12_Slopes_0DAFDF(uint8 cr);
void StdObj12_Slopes_GradualLeftSlope(void);
void StdObj12_Slopes_GradualRightSlope(void);
void StdObj12_Slopes(uint8 k);
void StdObj12_SlopesLeftSlope(void);
void StdObj12_SlopesRightSlope(void);
void StdObj12_Slopes_SteepLeftSlope(void);
void StdObj12_Slopes_SteepRightSlope(void);
void StdObj12_Slopes_UpsideDownNormalLeftSlope(void);
void StdObj12_Slopes_UpsideDownNormalRightSlope(void);
void StdObj12_Slopes_UpsideDownSteepLeftSlope(void);
void StdObj12_Slopes_UpsideDownSteepRightSlope(void);
void StdObj13_GroundEdgesAndVine(uint8 k);
void StdObj15_MidwayAndGoalPoint(uint8 k);
void StdObj16_PurpleCoins(uint8 k);
void StdObj17_RopeAndCloudLine(uint8 k);
void StdObj1C_DonutBridge(uint8 k);
void StdObj1D_ClimbingNetWithBottomEdge(uint8 k);
void StdObj1E_ClimbingNetWithSideEdge_0DB4D9(uint8 k, uint8 j, uint8 a);
void StdObj1E_ClimbingNetWithSideEdge_0DB4FE(uint8 k, uint8 j, uint8 a);
void StdObj1E_ClimbingNetWithSideEdge(uint8 k);
void StdObj1F_SkinnyVerticalPipeBoneLog(uint8 k);
void StdObj20_SkinnyHorizontalPipeBoneLog(uint8 k);
void StdObj21_WideScaleGroundLedge_0DB1E3(uint8 k, uint8 r0, uint8 r2);
void StdObj21_WideScaleGroundLedge(uint8 k);
void StdObj21_WideScaleGroundLedge_StandardLedgeEntry(uint8 k);
void StdObjXX_Generic1RepeatedTileObject_IcyTurnBlockEntry(uint8 k);
void UndergroundObj36_4SidedGround(uint8 k);
void UndergroundObj37_LargeCanvas(uint8 k);
void UndergroundObj38_RightLavaEdge_0DDAE8(uint8 k, uint8 j, uint8 a, uint8 r0);
void UndergroundObj38_RightLavaEdge(uint8 k);
void UndergroundObj39_SlopedCaveLava_0DDBA4(uint8 j, uint8 r0, uint8 r2);
void UndergroundObj39_SlopedCaveLava(uint8 k);
void UndergroundObj39_SlopedCaveLavaLeftSlope(void);
void UndergroundObj39_SlopedCaveLavaRightSlope(void);
void UndergroundObj39_SlopedCaveLava_SteepLeftSlope(void);
void UndergroundObj39_SlopedCaveLava_SteepRightSlope(void);
void UndergroundObj3B_CaveLava(uint8 k);
void UndergroundObj3C_VerySteepSlope(uint8 k);
void UndergroundObj3C_VerySteepSlope_VerySteepLeftSlope(void);
void UndergroundObj3C_VerySteepSlope_VerySteepRightSlope(void);
void UndergroundObj3D_CeilingLedge(uint8 k);
void UndergroundObj3E_CeilingEdges(uint8 k);
void UndergroundObj3F_SolidDirt(uint8 k);

void LmStdObj22_DirectMap16(uint8 k);
void LmStdObj23(uint8 k);
void LmStdObj24(uint8 k);
void LmStdObj25(uint8 k);
void LmStdObj26_MusicBypass(uint8 k);
void LmStdObj27(uint8 k);
void LmStdObj28(uint8 k);
void LmStdObj29(uint8 k);

void LmHook_InitExanimForLevel(void);
void LmHook_UploadLevelAnimations(void);
void LmHook_BeginLoadingLevelDataB(void);
void LmHook_PrepareLevel(void);
void LmFunc1_CustomPalettes(int a);
void LmHook_UploadGraphicsFiles(void);
uint8 LmFunc15_DecompressSlot(uint8 a);
void LmGraphicsDecompress(uint16 a);

const uint8 *LmHook_UploadGFXFile(uint8 a, uint8 index);

uint8 LmFunc18_GetFF200(uint8 a, uint8 k);

uint8 LmHook_ModifyMap16IDForSpecialBlocks(uint8 a);
uint8 LmFunc20_ModifyMap16IDForSpecialBlocks(uint8 a);

uint8 *LmHook_GraphicsDecompress(uint8 a);
void LmHandleDirectMapObjs(uint8 a);

void LmHook_LoadSpritesOnLevelLoad(void);
void LmHook_LoadLevelInfo(void);
void LmHook_BufferCreditsBackgrounds(void);
void LmHook_LoadLevel(uint16 j);
void LmHook_LoadLevelB(const uint8 *ptr_layer1_data, uint8 R2, uint16 level_number);
uint16 LmFunc_InitScreenTables(int k, int a);
void LmHook_HandleStandardLevelCameraScroll(void);
bool LmHook_GameMode11_LoadSublevel(void);

void LmHook_UploadLevelLayer1And2Tilemaps(void);

void LmHook_BE8A(uint16 xbase);

void LmHook_PreserveLevelDataPointerInObjects(void);
void LmHook_RestoreLevelDataPointerInObjects(void);
uint8 LmHook_HandleHorizontalSubScreenCrossingForCurrentObject_Entry2(void);
uint8 LmHook_HandleVerticalSubScreenCrossingForCurrentObject(void);
void LmFunc_DF1C3(uint8 k, uint8 a);

void LmHook_InitializeLevelLayer1And2Tilemaps(void);
void LmHook_CheckIfLevelTilemapsNeedScrollUpdate(void);

void LmHook_BufferTilemap_L1(void);
void LmHook_BufferTilemap_L2(void);
void LmHook_UploadLevelLayer1And2Tilemaps(void);

void Lm_BufferTilemap_L1_0(void);
void Lm_BufferTilemap_L1_1(void);
void LmHook_BufferScrollingTiles_L2_Background(void);
void LmHook_BufferScrollingTiles_L2_1(void);
void LmHook_BufferScrollingTiles_L2_7(void);
void LmHook_BufferScrollingTiles_L2_7(void);
void LmFunc_UpdateTilemapA_0(void);
void LmFunc_UpdateTilemapB_0(void);
void LmFunc_UpdateTilemapB_7(void);
void LmFunc_UpdateTilemapC_0(void);
void LmFunc_UpdateTilemapD_0(void);
void LmFunc_UpdateTilemapD_1(void);
void LmFunc_UpdateTilemapD_2(void);

void Lm_CopyTilesToL1UploadBuffer(const uint8 *plo, const uint8 *phi, uint16 j, uint16 r6);
void Lm_SetupLmVramDma_0(void);
void Lm_SetupLmVramDma_6(void);
void Lm_SetupLmVramDma_12(void);
void Lm_SetupLmVramDma_16(void);
void Lm_SetupPipeTiles(uint16 a);
const uint16 *Lm_GetMap16RomAddr(uint16 a);

uint16 *LmHook_CustomBgMap16(void);
void Lm_CopyToVramBufD_6(const uint8 *plo, const uint8 *phi, uint16 j, const uint16 *ptile);
void Lm_SetupLmVramDma_6(void);

void LmHook_LevelTileAnimations(void);

typedef struct ParseTileAnimCtx {
  const uint8 *p, *porg;
  uint8 *r8;
  uint8 r10;
  LongPtr ptr;
} ParseTileAnimCtx;

void LmFunc_10C713(LongPtr p, uint16 r8, uint8 r10, uint16 k);

void LmHook_SetStandardPPUSettings(void);
void LmHook_HandleStandardLevelCameraScrollB(void);
void LmHook_HandleStandardLevelCameraScrollC(void);
uint16 LmHook_HandleStandardLevelCameraScrollD(void);
uint16 LmHook_HandleStandardLevelCameraScrollG(uint16 r2, uint16 r4);
uint16 LmHook_LoadStripeImage(uint16 r3);

void LmHook_GameMode0C_LoadOverworld(uint16 k);

const uint16 *LmHook_TileGen(uint16 j);
bool LmHook_WantEraseSprite(uint16 k, uint16 y);
void LmHook_OwGraphicsDecompress(void);

uint16 LmHook_LoadLevelInfo_A(uint16 a, uint16 k);
uint16 LmHook_LoadLevelInfo_C(uint16 a);

void LmHook_ExpandLvlHdr(uint16 lvl);

bool LmHook_CustomTitleScreenDemo(void);
void LmHook_InitializeSaveData(void);
void LmHook_DisplayMessage(void);
void LmHook_OverworldPalette(void);
void LmHook_LevelNamesPatch(uint16 a);
int LmHook_LoadLevelInfo_E(uint16 k, uint16 lvl, uint8 r0, uint8 r1);

uint16 LmHook_DestroyTileAnimation2(uint16 a);
const uint8* LmHook_DestroyTileAnimation3(uint16 k);
uint16 LmHook_RemapDestroyTile(uint16 a);

void LmHook_EventStuff(uint8 a, bool from_where);

void LmFunc_UploadGraphics_StepA(void);
void LmFunc_UpdateBG12NBA(void);
void LmHook_InitializeLevelLayer3_GenerateInteractiveTideWater(void);

uint16 GetLevelLayoutPtr_Vertical(int i);
uint16 GetLevelLayoutPtr_Horizontal(int i);

enum {
  kLmFeature_LmEnabled = 1 << 0,
  kLmFeature_Exanim = 1 << 1,
  kLmFeature_SkipOverworldDecompress = 1 << 2,
  kLmFeature_OverworldTiles4bpp = 1 << 3,
  kLmFeature_Copy512colors = 1 << 4,
  kLmFeature_WeirdPalette = 1 << 5,
  kLmFeature_SkipLoadPaletteHook = 1 << 6,
  kLmFeature_GfxUpload = 1 << 7,
  kLmFeature_LoadLevel = 1 << 8,
  kLmFeature_4bppgfx = 1 << 9,
  kLmFeature_CustomTitleScreenDemo = 1 << 10,
  kLmFeature_CustomDisplayMessage = 1 << 11,
  kLmFeature_DontSetYposForIntroMarch = 1 << 12,
  kLmFeature_OwPalette = 1 << 13,
  kLmFeature_LevelNamesPatch = 1 << 14,
  kLmFeature_DestroyTileAnims = 1 << 15,
  kLmFeature_EventStuff = 1 << 16,
  kLmFeature_MusicRegTweak = 1 << 17,
  kLmFeature_TideWaterTweak = 1 << 18,
  kLmFeature_EnemyCollTweak = 1 << 19,
  kLmFeature_Ow4bppGfx = 1 << 20,
  kLmFeature_DontResetOwPlayersMap = 1 << 21,
  kLmFeature_NonStdGfxAA8D = 1 << 22,
  kLmFeature_TimerTweaks = 1 << 23,
  kLmFeature_NoDefaultSavePrompts = 1 << 24,
};

// Non lunar magic hacks
enum {
  kHack_Walljump = 1 << 0,
};

typedef struct LmFeatures {
  uint32 flags;
  uint32 kLmLvlInfo_addr;
  uint32 kLmLvlInfo_addr_other;
  uint32 hacks;
} LmFeatures;

#define LM_FEATURES ((LmFeatures *)kLmFeatures)
#define HAS_LM_FEATURE(i) ((LM_FEATURES->flags & (i)) != 0)
#define HAS_HACK(i) ((LM_FEATURES->hacks & (i)) != 0)

void HackHandleWalljump();

#endif  // SMW_FUNCS_H_